// ChildView.cpp : Implementatierung der Klasse CChildView
//

#include "stdafx.h"
#include "Servo.h"
#include "HexMotion.h"
#include "DlgStatus.h"
#include "ChildView.h"
#include "MainFrm.h"
#include "Plattform.h"
#include "Joystick.h"
#include "X_3DMouse.h"
#include "Script.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//following line added by S.Wei, last change/add 20.11.2007
HEXAPOD_KEYBOARD	CChildView::keyboard;

CChildView::CChildView()
{	
	CDlgStatus* pDlgStatus;
	pDlgStatus= new CDlgStatus();
	int m_nTimer = 0; //added by S.Wei 28.08.2007
	TRACE("CChildView::CChildView()\n");	
	
	//Fenster in der Liste aus Fensterzeigern aufnehmen, 0 = nchstgrere freie Nummer, unter dem Namen CChildView
	IP_SETNAMED("m_pWnd", this, 0, "CChildView"); 
	m_bKeyDown  = false;
	isRecording = false;
}

CChildView::~CChildView()
{	
	TRACE("CChildView::~CChildView()\n"); //Statusausgabe fr Debugzwecke
	CDlgStatus* pDlgStatus;
	pDlgStatus=CDlgStatus::m_pCDlgStatus;
	if (pDlgStatus) delete(pDlgStatus);
}

BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ACTIVATE()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEWHEEL()
	ON_WM_RBUTTONUP()
	ON_WM_MBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP 
END_MESSAGE_MAP() 

void CChildView::InitKeyboard()
{
	keyboard.left	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "left");
	keyboard.right	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","right");
	keyboard.up		= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard",   "up");
	keyboard.down	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "down");
	keyboard.front	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","front");
	keyboard.back	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "back");
	
	keyboard.leftdown	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "leftdown");
	keyboard.rightdown	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","rightdown");
	keyboard.leftback	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "leftback");
	keyboard.rightback	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","rightback");
	keyboard.frontdown	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","frontdown");
	keyboard.backdown	= (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard", "backdown");

	keyboard.zeroposition = (UINT)CIniFile::m_pCIniFile->GetValueInt("keyboard","zeroposition");
}

//following methode added by S.Wei 09.10.2007
void CChildView::InitCamera()
{
	//http://www.thescripts.com/forum/thread261281.html
	//http://msdn2.microsoft.com/en-us/library/ms629848.aspx
	HRESULT e;
	IWiaDevMgr *iDM = NULL;
	IWiaItem *iroot = NULL;
	e = CoInitialize(NULL);
	e = CoCreateInstance(CLSID_WiaDevMgr, NULL, CLSCTX_ALL, IID_IWiaDevMgr, (LPVOID *)&iDM);
	e = iDM->SelectDeviceDlg(NULL, 1 /*StiDeviceTypeScanner*/, WIA_SELECT_DEVICE_NODEFAULT/*0*/, NULL, &iroot);
	
}

/////////////////////////////////////////////////////////////////////////////
// Nachrichtenbehandlungsroutinen von CChildView

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS|CS_OWNDC, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);
	//CS_OWNDC wurde hinzugefgt, um eine "AccessViolation GDI32.dll zu vermeiden
	//"...Nicht abgefangene Ausnahme in Cube3.exe (GDI32.DLL): 0xC0000005: Access Violation...."
	return TRUE;
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//Umbau 13.12.2007 S.Wei
	//m_OpenGL.m_hWnd=m_hWnd;
	//m_OpenGL.m_pDC = new CClientDC(this);	//Neuen GerteKontext erzeugen und Zeiger darauf bergeben
	m_OpenGL.Init(this);
	
	/*following lines added by S.Wei, last change 20.11.2007*/
	InitKeyboard();
	InitCamera();
	if(CIniFile::m_pCIniFile->GetValueInt("joystick", "init"))
		new CJoystick();
	if(CIniFile::m_pCIniFile->GetValueInt("3Dmouse", "init"))
		new C3DMouse();//3D-Maus nutzbar machen
	
	PostMessage(WM_KEYUP); //diese Nachricht bewirkt die Aktualisierung der Anzeige //added by S.Wei, 24.04.2008
	return 0;
}

//following method added by S.Wei, 20.12.2007 
void CChildView::OnDestroy() 
{
	delete(CJoystick::m_pCJoystick);
	delete(C3DMouse::m_pC3DMouse);
}

//following method added by S.Wei
void CChildView::OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized)
{
	//Joystickroutine wird angehalten, sobald das Fenster nicht mehr das aktive ist,
	//wird es wieder aktiviert, luft die Joystickroutine weiter
	if(CJoystick::m_pCJoystick != NULL)
	{
		if((nState == WA_INACTIVE) || (bMinimized == TRUE))
		{
			if(CJoystick::JoyThreadIsRunning)
			{
				CJoystick::m_pCJoystick->StopJoystick();
			}
		}
		else
		{
			if(!CJoystick::JoyThreadIsRunning)
			{
				CJoystick::m_pCJoystick->StartJoystick();
			}
		}
	}
}

void CChildView::OnPaint() 
{
	m_OpenGL.DrawScene();

	CWnd::OnPaint(); //fehlt diese Zeile kommt es zur Vollauslastung des Prozessors 
}

//Following method added by S.Wei 03.12.2007
void CChildView::OnSetFocus(CWnd *pOldWnd)
{
	if(CJoystick::m_pCJoystick != NULL)
	{
		if(!CJoystick::JoyThreadIsRunning)
		{
			CJoystick::m_pCJoystick->StartJoystick();
		}
	}
}

//Following method added by S.Wei 03.12.2007
void CChildView::OnKillFocus(CWnd *pNewWnd)
{
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	float DeltaX = float(point.x-m_MousePosSave.x);
	float DeltaY = float(point.y-m_MousePosSave.y);
	
	float heading=m_OpenGL.m_pScene->m_fSceneAngle[0];
	float updown=m_OpenGL.m_pScene->m_fSceneAngle[1];
	float a=heading*CServo::piover180;
	float b=updown*CServo::piover180;
	
	if ((nFlags>0)||(m_bKeyDown))
	switch (m_OpenGL.m_pScene->m_nMouseUsage)
	{
	case MU_SCENE_TRANSLATE:
		moveScene(-(cos(a)*DeltaX-sin(a)*sin(b)*DeltaY), (cos(b)*DeltaY), -(sin(a)*DeltaX+cos(a)*sin(b)*DeltaY));
		break;
	case MU_SCENE_TRANSLATE_INTO:
		moveScene((sin(a)*cos(b)*DeltaY), -(sin(b)*DeltaY), -(cos(a)*cos(b)*DeltaY));
		break;
	case MU_SCENE_ROTATE:			
		moveScene(0,0,0,DeltaX,DeltaY, 0);
		break;
	}

	m_MousePosSave=point;	
	if ((nFlags)||(m_bKeyDown)) m_OpenGL.DrawScene();
	
	CWnd ::OnMouseMove(nFlags, point);
}

BOOL CChildView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	CPoint point;
	point.y = m_MousePosSave.y + zDelta/10;
	m_OpenGL.m_pScene->m_nMouseUsage = MU_SCENE_TRANSLATE_INTO;
	m_bKeyDown = true;
	OnMouseMove(nFlags, point);
	m_bKeyDown = false;
	m_OpenGL.m_pScene->m_nMouseUsage = MU_NO_USAGE;

	m_OpenGL.DrawScene();
	return CWnd ::OnMouseWheel(nFlags, zDelta, pt);
}



void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{	
	m_MousePosSave=point;
	CWnd ::OnLButtonDown(nFlags, point);
}
void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{	
	m_OpenGL.DrawScene();
	CWnd ::OnLButtonUp(nFlags, point);
}

void CChildView::OnMButtonDown(UINT nFlags, CPoint point) 
{
	m_MousePosSave=point;
	m_OpenGL.m_pScene->m_nMouseUsage=MU_SCENE_TRANSLATE;
	CWnd ::OnMButtonDown(nFlags, point);
}

void CChildView::OnMButtonUp(UINT nFlags, CPoint point) 
{
	m_OpenGL.m_pScene->m_nMouseUsage=MU_NO_USAGE;
	m_OpenGL.DrawScene();
	CWnd ::OnMButtonUp(nFlags, point);
}

void CChildView::OnRButtonDown(UINT nFlags, CPoint point)
{	
	m_MousePosSave=point;
	m_OpenGL.m_pScene->m_nMouseUsage=MU_SCENE_ROTATE;	
	CWnd ::OnRButtonDown(nFlags, point);
}

void CChildView::OnRButtonUp(UINT nFlags, CPoint point) 
{	
	m_OpenGL.m_pScene->m_nMouseUsage=MU_NO_USAGE;
	m_OpenGL.DrawScene();
	CWnd ::OnRButtonUp(nFlags, point);	
}



void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CPoint newpoint;
	m_bKeyDown=true;
	switch(nChar)
	{
		case VK_F2:	m_OpenGL.m_pScene->m_nMouseUsage=MU_SCENE_TRANSLATE;		break;
		case VK_F3:	m_OpenGL.m_pScene->m_nMouseUsage=MU_SCENE_TRANSLATE_INTO;	break;
		case VK_F4:	m_OpenGL.m_pScene->m_nMouseUsage=MU_SCENE_ROTATE;			break;

		case VK_F5: this->OnActionCommand(ID_RECORDER_AUFNAHME);	break;	//case added by S.Wei 03.01.2008, last change 12.02.2008
		case VK_F6: this->OnActionCommand(ID_RECORDER_WIEDERGABE);	break;	//case added by S.Wei 03.01.2008, last change 12.02.2008
		case VK_F7: this->OnActionCommand(ID_RECORDER_STOP);		break;	//case added by S.Wei 03.01.2008, last change 12.02.2008
			
		case VK_F8:		((CMainFrame *)IP_GET("m_pCMainFrame"))->FullScreen();		break; //added by S.Wei, 10.10.2007
		case VK_F9:		((CMainFrame *)IP_GET("m_pCMainFrame"))->dualView(true);	break; //added by S.Wei, last change 14.12.2007
		case VK_ESCAPE: ((CMainFrame *)IP_GET("m_pCMainFrame"))->dualView(false);	break; //added by S.Wei 14.12.2007, last change 17.02.2008
	
		case VK_TAB: //case added 17.02.2008
			//aus CMainFrame::OnToolBar bernommen
			//m_nPortSelect {0..3} -1=no connection
			if (gApp.m_SerialCom.IsConnected())
				gApp.m_SerialCom.ClosePort();
			else
			{	gApp.m_SerialCom.ClosePort();
				gApp.m_SerialCom.OpenPort(CIniFile::m_pCIniFile->GetValueInt("COM","port"));
			}
			break;
	}

	/*following 12 lines changed by S.Wei, last change 30.08.2007*/
	if(nChar == char(keyboard.left	)) this->OnActionCommand(ID_BTN_X_LEFT);
	if(nChar == char(keyboard.right	)) this->OnActionCommand(ID_BTN_X_RIGHT);
	if(nChar == char(keyboard.up	)) this->OnActionCommand(ID_BTN_Y_UP);
	if(nChar == char(keyboard.down	)) this->OnActionCommand(ID_BTN_Y_DOWN);
	if(nChar == char(keyboard.front	)) this->OnActionCommand(ID_BTN_Z_FRONT);
	if(nChar == char(keyboard.back	)) this->OnActionCommand(ID_BTN_Z_BACK);
	
	if(nChar == char(keyboard.rightback	)) this->OnActionCommand(ID_BTN_TRN_Y_1);
	if(nChar == char(keyboard.leftback	)) this->OnActionCommand(ID_BTN_TRN_Y_2);
	if(nChar == char(keyboard.frontdown	)) this->OnActionCommand(ID_BTN_TRN_X_1);
	if(nChar == char(keyboard.backdown	)) this->OnActionCommand(ID_BTN_TRN_X_2);
	if(nChar == char(keyboard.leftdown	)) this->OnActionCommand(ID_BTN_TRN_Z_1);
	if(nChar == char(keyboard.rightdown	)) this->OnActionCommand(ID_BTN_TRN_Z_2); 
	
	if(nChar == char(keyboard.zeroposition)) this->OnActionCommand(ID_BTN_CENTER_ZERO); //added by S.Wei 16.08.2007, last change 30.08.2007
	
	CWnd ::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{	
	m_bKeyDown=false;
	((CMainFrame *)IP_GET("m_pCMainFrame"))->m_nBtnSelected=0;
	m_OpenGL.m_pScene->m_nMouseUsage=MU_NO_USAGE;	
	m_OpenGL.DrawScene();
	CWnd ::OnKeyUp(nChar, nRepCnt, nFlags);
}

/*************** Methode zum berwachen eintreffender Nachrichten, added by S.Wei 17.09.2007*************/
BOOL CChildView::PreTranslateMessage(MSG* pMsg)
{
	if((C3DMouse::m_pC3DMouse != NULL) && (C3DMouse::m_pC3DMouse->PreTranslateMessage(pMsg)))
	{
		return true;
	}
	else
	{
		return CWnd::PreTranslateMessage(pMsg);
	}
}

//Following method added by S.Wei
//interpretates actions from interaktion devices and start this action 
void CChildView::ActionFromInteractionDevice(UINT action, float faktor)
{
	this->OnActionCommand(action, faktor);
	SendMessage(WM_KEYUP);//Diese Nachricht bewirkt die Aktualisierung der Anzeige
}

//Following method added by S.Wei
void CChildView::OnActionCommand(UINT action, float faktor)
{//ausgelagert und modifiziert am 02.01.2008, S.Wei, letzte nderung 12.02.2008
	float incr_translation= faktor * CPlattform::m_pCPlattform->m_dIncrTranslation;
	float incr_rotation= faktor * CPlattform::m_pCPlattform->m_dIncrRotation;
	
	((CMainFrame *)IP_GET("m_pCMainFrame"))->m_nBtnSelected=action;
	switch (action)
	{
	case ID_BTN_X_LEFT:
		movePlattform(-incr_translation);
		break;
	case ID_BTN_X_RIGHT:
		movePlattform( incr_translation);
		break;
	case ID_BTN_Y_UP:
		movePlattform(0,incr_translation);
		break;
	case ID_BTN_Y_DOWN:
		movePlattform(0,-incr_translation);
		break;
	case ID_BTN_Z_FRONT:
		movePlattform(0,0,incr_translation);
		break;
	case ID_BTN_Z_BACK:
		movePlattform(0,0,-incr_translation);
		break;
	case ID_BTN_TRN_X_1:
		movePlattform(0,0,0,-incr_rotation);
		break;
	case ID_BTN_TRN_X_2:
		movePlattform(0,0,0,incr_rotation);
		break;
	case ID_BTN_TRN_Y_1:
		movePlattform(0,0,0,0,incr_rotation);
		break;
	case ID_BTN_TRN_Y_2:
		movePlattform(0,0,0,0,-incr_rotation);
		break;
	case ID_BTN_TRN_Z_1:
		movePlattform(0,0,0,0,0,incr_rotation);
		break;
	case ID_BTN_TRN_Z_2:
		movePlattform(0,0,0,0,0,-incr_rotation);
		break;
	//following case added by S.Wei 16.08.2007, last change 02.01.2008
	case ID_BTN_CENTER_ZERO:
		setPlattform(ZERO_XPOS, ZERO_YPOS, ZERO_ZPOS, ZERO_XROT, ZERO_YROT, ZERO_ZROT);
		break;
	//eingefgt am 12.02.2008
	case ID_RECORDER_AUFNAHME: //case added by S.Wei, 03.01.2008
		if(CScript::m_pCScript == NULL)
		{
			CScript::m_pCScript = new CScript("recordfile.txt", false);
			setRecording(true);
		}
		break;
	case ID_RECORDER_WIEDERGABE: //case added by S.Wei 03.01.2008
		if(CScript::m_pCScript == NULL)
		{
			CScript::m_pCScript = new CScript("recordfile.txt", true);
		}
		break;
	case ID_RECORDER_STOP: //case added by S.Wei 03.01.2008
		if(CScript::m_pCScript != NULL)
		{
			setRecording(false);
			CScript::m_pCScript->StopScript();
			delete(CScript::m_pCScript);
		}
		break;
	}	
}

//following method added by S.Wei, 04.01.2008
void CChildView::setRecording(bool b)
{
	//http://msdn2.microsoft.com/en-us/library/95e68951(VS.80).aspx
	if((!isRecording) && b)
	{
		_ftime64(&startzeit); //Zeit nehmen
		((CMainFrame *)IP_GET("m_pCMainFrame"))->m_wndStatusBar->SetWindowText("Aufnahme gestartet");
	}
	if(isRecording && (!b))
	{
		((CMainFrame *)IP_GET("m_pCMainFrame"))->m_wndStatusBar->SetWindowText("Aufnahme beendet");
	}
   isRecording = b;
}

//following method added by S.Wei, 12.02.2008
bool CChildView::getRecording()
{
	return isRecording;
}

//----------------------------------      following 8 methods added by S.Wei, 02.01.2008        -----------------------------
void CChildView::recording()
{
	if((isRecording) && (CScript::m_pCScript != NULL))
	{
		struct __timeb64	ttime;
		_ftime64(&ttime);
		UINT difftime = (UINT) (ttime.time*1000 + ttime.millitm - startzeit.time*1000 - startzeit.millitm); 
		float position[3];
		float angles[3];
		CPlattform::m_pCPlattform->GetPosition(position);
		CPlattform::m_pCPlattform->GetOrientation(angles);
		CScript::m_pCScript->OnAction(position[0], position[1], position[2], angles[1], angles[0], angles[2], difftime, 0, 0);
	}
	else
	{
		((CMainFrame *)IP_GET("m_pCMainFrame"))->m_wndStatusBar->SetWindowText("Bereit");
	}
}
		
//absolute Plattformpunkt- & -ausrichtungseinstellung
void CChildView::setPlattform(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	TrimValue(rx, 0.0, 360.0);
	TrimValue(ry, 0.0, 360.0);
	TrimValue(rz, 0.0, 360.0);
	
	if(step > 1)
	{
		float pos[3];
		CPlattform::m_pCPlattform->GetPosition(pos);
		x = pos[0] + (x - pos[0])/step;
		y = pos[1] + (y - pos[1])/step;
		z = pos[2] + (z - pos[2])/step;
		CPlattform::m_pCPlattform->GetOrientation(pos);
		rx = pos[1] + (rx - pos[1])/step;
		ry = pos[0] + (ry - pos[0])/step;
		rz = pos[2] + (rz - pos[2])/step;
		TrimValue(rx, 0.0, 360.0);
		TrimValue(ry, 0.0, 360.0);
		TrimValue(rz, 0.0, 360.0);
	}

	CPlattform::m_pCPlattform->SetPosition(x, y, z);
	CPlattform::m_pCPlattform->SetOrientation(ry, rx, rz);

	aktualisieren();
}

//relative Plattformpunkt- & -ausrichtungsnderung
void CChildView::movePlattform(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	if(step == 0)//kein Schritt
		return;

	float pos[3];
	if((x != 0) | (y != 0) | (z != 0))
	{
		CPlattform::m_pCPlattform->GetPosition(pos);
		pos[0]+=x/step;
		pos[1]+=y/step;
		pos[2]+=z/step;
		CPlattform::m_pCPlattform->SetPosition(pos);
	}		
	if((rx != 0) | (ry != 0) | (rz != 0))
	{
		CPlattform::m_pCPlattform->GetOrientation(pos);
		TrimValue(pos[1]+=rx/step, 0.0, 360.0);
		TrimValue(pos[0]+=ry/step, 0.0, 360.0);
 		TrimValue(pos[2]+=rz/step, 0.0, 360.0);
		CPlattform::m_pCPlattform->SetOrientation(pos);
	}

	aktualisieren();
}

//absoluter Gesichtspunkt & -richtung einstellen
void CChildView::setView(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	TrimValue(rx, 0.0, 360.0);
	TrimValue(ry, 0.0, 360.0);
	TrimValue(rz, 0.0, 360.0);
	
	if(step > 1)
	{
		x = m_OpenGL.m_pScene->m_fViewPosition[0] + (x - m_OpenGL.m_pScene->m_fViewPosition[0])/step;
		y = m_OpenGL.m_pScene->m_fViewPosition[1] + (y - m_OpenGL.m_pScene->m_fViewPosition[1])/step;
		z = m_OpenGL.m_pScene->m_fViewPosition[2] + (z - m_OpenGL.m_pScene->m_fViewPosition[2])/step;
		
		rx = m_OpenGL.m_pScene->m_fViewAngle[0] + (rx - m_OpenGL.m_pScene->m_fViewAngle[0])/step;
		ry = m_OpenGL.m_pScene->m_fViewAngle[1] + (ry - m_OpenGL.m_pScene->m_fViewAngle[1])/step;
		rz = m_OpenGL.m_pScene->m_fViewAngle[2] + (rz - m_OpenGL.m_pScene->m_fViewAngle[2])/step;
		
		TrimValue(rx, 0.0, 360.0);
		TrimValue(ry, 0.0, 360.0);
		TrimValue(rz, 0.0, 360.0);
	}

	m_OpenGL.m_pScene->m_fViewPosition[0] = x;
	m_OpenGL.m_pScene->m_fViewPosition[1] = y;
	m_OpenGL.m_pScene->m_fViewPosition[2] = z;

	m_OpenGL.m_pScene->m_fViewAngle[0] = rx;
	m_OpenGL.m_pScene->m_fViewAngle[1] = ry;
	m_OpenGL.m_pScene->m_fViewAngle[2] = rz;
}

//relative Gesichtspunkt- & -richtungsnderung
void CChildView::moveView(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	if(step == 0)//kein Schritt
		return;

	m_OpenGL.m_pScene->m_fViewPosition[0] += x/step;
	m_OpenGL.m_pScene->m_fViewPosition[1] += y/step;
	m_OpenGL.m_pScene->m_fViewPosition[2] += z/step;
	
	TrimValue(m_OpenGL.m_pScene->m_fViewAngle[0] += rx/step, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fViewAngle[1] += ry/step, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fViewAngle[2] += rz/step, 0.0, 360.0);
}

//absoluter Modellpunkt & -ausrichtung einstellen
void CChildView::setScene(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	if(step > 1)
	{
		TrimValue(rx, 0.0, 360.0);
		TrimValue(ry, 0.0, 360.0);
		TrimValue(rz, 0.0, 360.0);
	
		x = m_OpenGL.m_pScene->m_fScenePosition[0] + (x - m_OpenGL.m_pScene->m_fScenePosition[0])/step;
		y = m_OpenGL.m_pScene->m_fScenePosition[1] + (y - m_OpenGL.m_pScene->m_fScenePosition[1])/step;
		z = m_OpenGL.m_pScene->m_fScenePosition[2] + (z - m_OpenGL.m_pScene->m_fScenePosition[2])/step;
		
		rx = m_OpenGL.m_pScene->m_fSceneAngle[0] + (rx - m_OpenGL.m_pScene->m_fSceneAngle[0])/step;
		ry = m_OpenGL.m_pScene->m_fSceneAngle[1] + (ry - m_OpenGL.m_pScene->m_fSceneAngle[1])/step;
		rz = m_OpenGL.m_pScene->m_fSceneAngle[2] + (rz - m_OpenGL.m_pScene->m_fSceneAngle[2])/step;		
	}

	m_OpenGL.m_pScene->m_fScenePosition[0] = x;
	m_OpenGL.m_pScene->m_fScenePosition[1] = y;
	m_OpenGL.m_pScene->m_fScenePosition[2] = z;
	
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[0] = rx, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[1] = ry, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[2] = rz, 0.0, 360.0);
}

//relative	Modellpunkt- & -ausrichtungsnderung
void CChildView::moveScene(float x, float y, float z/*=0*/, float rx/*=0*/, float ry/*=0*/, float rz/*=0*/, UINT step /*= 1*/)
{
	if(step == 0)//kein Schritt
		return;

	m_OpenGL.m_pScene->m_fScenePosition[0] += x/step;
	m_OpenGL.m_pScene->m_fScenePosition[1] += y/step;
	m_OpenGL.m_pScene->m_fScenePosition[2] += z/step;
	
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[0] += rx/step, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[1] += ry/step, 0.0, 360.0);
	TrimValue(m_OpenGL.m_pScene->m_fSceneAngle[2] += rz/step, 0.0, 360.0);
}

//bewegt alle virtuellen und reelen Servo-Motoren (=> Plattformen)
void CChildView::aktualisieren()
{
	CServo::MoveAllServos(); //change by S.Wei, 21.12.2007
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
	recording();
}

//----------------------------------      previous 8 methods added by S.Wei, 02.01.2008        -----------------------------
