// DlgConfigKeyboard.cpp : implementation file //created S.Wei, last change/add 03.09.2007
//

#include "stdafx.h"
#include "HexMotion.h"
#include "DlgConfigKeyboard.h"
#include "IniFile.h"

bool CDlgConfigKeyboard::m_bIsActive = false;
CEvent CDlgConfigKeyboard::g_resumeThread;
// DlgConfigKeyboard dialog


CDlgConfigKeyboard::CDlgConfigKeyboard(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgConfigKeyboard::IDD, pParent)
{
	m_bIsActive = false;
	saveChange = FALSE;
	lpKeyboard = NULL;
	waitForID = 0;
}

CDlgConfigKeyboard::~CDlgConfigKeyboard()
{
}


void CDlgConfigKeyboard::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgConfigKeyboard)
 for (int i = 0; i<13; i++) {
  TCHAR buf[32];
  UINT vk_code = lpKeyboard->vk_keys[i];
  LONG scancode = MapVirtualKey(vk_code,0)<<16;
// Extended-Flag zuerst probieren: ergibt sprechende Bezeichnung statt "1 (Numpad)"
  int len = GetKeyNameText(scancode | (1<<24),buf,elemof(buf));
// Ohne Extended-Flag: fr normale Tasten
  if (!len || buf[0]==' ') len = GetKeyNameText(scancode,buf,elemof(buf));
  if (len) CharLowerBuff(buf+1,len-1);
  SetDlgItemText(IDC_Key_Conf_SET_LEFT+i,buf);
 }
	DDX_Check(pDX, IDC_SAVE_CHANGE, saveChange);
	//}}AFX_DATA_MAP
}

BOOL CDlgConfigKeyboard::OnInitDialog()
{
	if(lpKeyboard == NULL)
	{
		if(((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView")) == NULL)
		{
			return false;
		}
		//{{AFX_DATA_INIT(CDlgConfigKeyboard)
		keyboard = ((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->keyboard;
		lpKeyboard = &keyboard;
		//}}AFX_DATA_INIT
	}
	CDialog::OnInitDialog();
	return true;
}

BEGIN_MESSAGE_MAP(CDlgConfigKeyboard, CDialog)
	//{{AFX_MSG_MAP(CDlgConfigKeyboard)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_LEFT, OnBnClickedKeyConfBtnSetLeft)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_RIGHT, OnBnClickedKeyConfBtnSetRight)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_FRONT, OnBnClickedKeyConfBtnSetFront)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_BACK, OnBnClickedKeyConfBtnSetBack)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_UP, OnBnClickedKeyConfBtnSetUp)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_DOWN, OnBnClickedKeyConfBtnSetDown)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_LEFT_DOWN, OnBnClickedKeyConfBtnSetLeftDown)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_RIGHT_DOWN, OnBnClickedKeyConfBtnSetRightDown)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_FRONT_DOWN, OnBnClickedKeyConfBtnSetFrontDown)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_BACK_DOWN, OnBnClickedKeyConfBtnSetBackDown)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_LEFT_BACK, OnBnClickedKeyConfBtnSetLeftBack)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_RIGHT_BACK, OnBnClickedKeyConfBtnSetRightBack)
	ON_BN_CLICKED(IDC_Key_Conf_BTN_SET_ZERO_POSITION, OnBnClickedKeyConfBtnSetZeroPosition)
	ON_BN_CLICKED(ID_NEW_CONFIGURATION, OnBnClickedNewConfiguration)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDlgConfigKeyboard message handlers

void CDlgConfigKeyboard::OnOK() {
 UpdateData(true);

 ((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->keyboard = keyboard;

 if (saveChange) {
  static const char IniKeys[]="left\0" "right\0" "up\0" "down\0" "front\0" "back\0"
    "leftdown\0" "rightdown\0" "leftback\0" "rightback\0" "frontdown\0" "backdown\0" "zeroposition\0";
  const char *key=IniKeys;
  for (int i=0; i<13; i++) {
   CIniFile::m_pCIniFile->SetValue("keyboard", key,(int)keyboard.vk_keys[i]);
   key += lstrlen(key)+1;
  }
  ENSURE(!*key);
  CIniFile::m_pCIniFile->WriteFile();
 }
 OnCancel();
}

int CDlgConfigKeyboard::OnCreateKeyboardConfigDialog(LPCREATESTRUCT lpCreateStruct)
{
	return 1;
}


void CDlgConfigKeyboard::OnCancel()
{
	m_bIsActive = false;
	saveChange = FALSE;
	if(keyChangeThread != NULL)
	{
		g_resumeThread.SetEvent();
		keyChangeThread = NULL;
	}
	lpKeyboard = NULL;
	DestroyWindow();
}


void CDlgConfigKeyboard::OnBnClicked(UINT ActionID)
{
	GetDlgItem((int) ActionID)->GetDC()->SetBkColor(255);
	waitForID = ActionID;
}

BOOL CDlgConfigKeyboard::PreTranslateMessage(MSG* pMsg)
{
	if((pMsg->message == WM_KEYDOWN) && (waitForID >= IDC_Key_Conf_SET_LEFT) && (waitForID <= IDC_Key_Conf_SET_ZERO_POSITION))
	{
		UINT nChar = pMsg->wParam;
		lpKeyboard->vk_keys[waitForID - IDC_Key_Conf_SET_LEFT] = nChar;
		CDialog::OnInitDialog();
		GetDlgItem((int) waitForID)->ModifyStyleEx(WS_EX_CLIENTEDGE,0);
		waitForID = 0;
		if(keyChangeThread != NULL)
		{
			g_resumeThread.SetEvent();
		}
		return true;
	}
	else
	{
		return CDialog::PreTranslateMessage(pMsg);
	}
}

void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetLeft()			{OnBnClicked(IDC_Key_Conf_SET_LEFT	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetRight()		{OnBnClicked(IDC_Key_Conf_SET_RIGHT	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetFront()		{OnBnClicked(IDC_Key_Conf_SET_FRONT	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetBack()			{OnBnClicked(IDC_Key_Conf_SET_BACK	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetUp()			{OnBnClicked(IDC_Key_Conf_SET_UP	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetDown()			{OnBnClicked(IDC_Key_Conf_SET_DOWN	);}

void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetLeftDown()		{OnBnClicked(IDC_Key_Conf_SET_LEFT_DOWN	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetRightDown()	{OnBnClicked(IDC_Key_Conf_SET_RIGHT_DOWN);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetFrontDown()	{OnBnClicked(IDC_Key_Conf_SET_FRONT_DOWN);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetBackDown()		{OnBnClicked(IDC_Key_Conf_SET_BACK_DOWN	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetLeftBack()		{OnBnClicked(IDC_Key_Conf_SET_LEFT_BACK	);}
void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetRightBack()	{OnBnClicked(IDC_Key_Conf_SET_RIGHT_BACK);}

void CDlgConfigKeyboard::OnBnClickedKeyConfBtnSetZeroPosition()	{OnBnClicked(IDC_Key_Conf_SET_ZERO_POSITION);}


void CDlgConfigKeyboard::OnBnClickedNewConfiguration()
{
	ZeroMemory(&keyboard, sizeof(HEXAPOD_KEYBOARD));
	CDialog::OnInitDialog();
	keyChangeThread = AfxBeginThread(&CDlgConfigKeyboard::NewConfigurationThread, this, THREAD_PRIORITY_NORMAL);
}

UINT _cdecl CDlgConfigKeyboard::NewConfigurationThread(LPVOID pParam)
{
	for(int i = IDC_Key_Conf_SET_LEFT; (i <= IDC_Key_Conf_SET_ZERO_POSITION) && m_bIsActive; i++)
	{
		static_cast <CDlgConfigKeyboard *>(pParam)->OnBnClicked(i);
		::WaitForSingleObject(g_resumeThread,INFINITE);
	}
	return 0;
}
