#pragma once

#include "ChildView.h"
#include <afxmt.h>

// DlgConfigKeyboard dialog

class CDlgConfigKeyboard : public CDialog
{
private:
	UINT	waitForID;
	int		saveChange;
	HEXAPOD_KEYBOARD	keyboard;
	LPHEXAPOD_KEYBOARD	lpKeyboard;
	

public:
	CDlgConfigKeyboard(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgConfigKeyboard();

	virtual void OnOK();
	virtual void OnCancel();

	void OnBnClicked(UINT ActionID);
	BOOL PreTranslateMessage(MSG* pMsg);
	
	CWinThread *keyChangeThread;

	static bool m_bIsActive;
	static CEvent g_resumeThread;
	static UINT _cdecl NewConfigurationThread(LPVOID pParam);
	
	
// Dialog Data
	//{{AFX_DATA(CDlgConfigKeyboard)
	enum { IDD = IDD_KONFIG_KEYBOARD };	
	//}}AFX_DATA


	//{{AFX_VIRTUAL(CDlgConfigKeyboard)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
protected:
	virtual BOOL OnInitDialog();
	
public:
	//{{AFX_MSG(CDlgConfigKeyboard)
	afx_msg int OnCreateKeyboardConfigDialog(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnBnClickedKeyConfBtnSetLeft();
	afx_msg void OnBnClickedKeyConfBtnSetRight();
	afx_msg void OnBnClickedKeyConfBtnSetUp();
	afx_msg void OnBnClickedKeyConfBtnSetDown();
	afx_msg void OnBnClickedKeyConfBtnSetFront();
	afx_msg void OnBnClickedKeyConfBtnSetBack();
	afx_msg void OnBnClickedKeyConfBtnSetLeftBack();
	afx_msg void OnBnClickedKeyConfBtnSetRightBack();
	afx_msg void OnBnClickedKeyConfBtnSetBackDown();
	afx_msg void OnBnClickedKeyConfBtnSetFrontDown();
	afx_msg void OnBnClickedKeyConfBtnSetLeftDown();
	afx_msg void OnBnClickedKeyConfBtnSetRightDown();
	afx_msg void OnBnClickedKeyConfBtnSetZeroPosition();
	afx_msg void OnBnClickedNewConfiguration();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

