// DlgObjectSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "math.h"
#include "resource.h"
#include "gl\gl.h"			//OpenGL - Standartbefehle	z.B. glVertex3d(), ...
#include "gl\glu.h"			//OpenGL - Utilities		z.B. gluPerspective(), ...
//#include "gl\glaux.h"		//OpenGL - Hilfsbibliothek	z.B. auxSolidSphere(), ...
#include "OpenGLLight.h"
#include "OpenGLScene.h"
#include "OpenGLObject.h"
#include "OpenGLFunctions.h"
#include "DlgLightSettings.h"
#include "DlgObjectSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgObjectSettings 


CDlgObjectSettings::CDlgObjectSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgObjectSettings::IDD, pParent)
{
	ZeroMemory(&m_dPos,sizeof(float)*16+sizeof(BOOL)*2+sizeof(bool));
	//{{AFX_DATA_INIT(CDlgObjectSettings)
	m_strObjectList = _T("");
	m_strGeometrieFile = _T("");
/*	m_bIsActive=false;
	m_dPosX = 0.0;
	m_dPosY = 0.0;
	m_dPosZ = 0.0;
	m_dPosOffsetX = 0.0;
	m_dPosOffsetY = 0.0;
	m_dPosOffsetZ = 0.0;
	m_dOrientationA = 0.0;
	m_dOrientationB = 0.0;
	m_dOrientationC = 0.0;
	m_dOrientationOffsetA = 0.0;
	m_dOrientationOffsetB = 0.0;
	m_dOrientationOffsetC = 0.0;
	m_bShowOrigin = FALSE;
	m_bShowGeometry = FALSE;
	m_dColorR = 0.0;
	m_dColorG = 0.0;
	m_dColorB = 0.0;
	m_dColorAlpha = 0.0;*/
	//}}AFX_DATA_INIT
}

void CDlgObjectSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgObjectSettings)
	DDX_Control(pDX, IDC_OBJECT_LIST, m_ctlObjectList);
	DDX_CBString(pDX, IDC_OBJECT_LIST, m_strObjectList);
	DDX_Text(pDX, IDC_EDIT_POS+0, m_dPos[0]);
	DDX_Text(pDX, IDC_EDIT_POS+1, m_dPos[1]);
	DDX_Text(pDX, IDC_EDIT_POS+2, m_dPos[2]);
	DDX_Text(pDX, IDC_EDIT_OFFSET+0, m_dPosOffset[0]);
	DDX_Text(pDX, IDC_EDIT_OFFSET+1, m_dPosOffset[1]);
	DDX_Text(pDX, IDC_EDIT_OFFSET+2, m_dPosOffset[2]);
	DDX_Text(pDX, IDC_EDIT_ORIENTATION+0, m_dOrientation[0]);
	DDX_Text(pDX, IDC_EDIT_ORIENTATION+1, m_dOrientation[1]);
	DDX_Text(pDX, IDC_EDIT_ORIENTATION+2, m_dOrientation[2]);
	DDX_Text(pDX, IDC_EDIT_OFFSETO+0, m_dOrientationOffset[0]);
	DDX_Text(pDX, IDC_EDIT_OFFSETO+1, m_dOrientationOffset[1]);
	DDX_Text(pDX, IDC_EDIT_OFFSETO+2, m_dOrientationOffset[2]);
	DDX_Check(pDX, IDC_CHK_SHOW_ORIGIN, m_bShowOrigin);
	DDX_Check(pDX, IDC_CHK_SHOW_GEOMETRY, m_bShowGeometry);
	DDX_Text(pDX, IDC_EDIT_COLOR+0, m_dColor[0]);
	DDX_Text(pDX, IDC_EDIT_COLOR+1, m_dColor[1]);
	DDX_Text(pDX, IDC_EDIT_COLOR+2, m_dColor[2]);
	DDX_Text(pDX, IDC_EDIT_COLOR+3, m_dColor[3]);
	DDX_Text(pDX, IDC_EDIT_GEOMETRY_PATH, m_strGeometrieFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgObjectSettings, CDialog)
	//{{AFX_MSG_MAP(CDlgObjectSettings)
	ON_CBN_SELCHANGE(IDC_OBJECT_LIST, OnSelchangeObjectList)
	ON_BN_CLICKED(IDC_BTN_UPDATE, OnBtnUpdate)
	ON_BN_CLICKED(IDC_CHK_SHOW_ORIGIN, OnChkShowOrigin)
	ON_BN_CLICKED(IDC_CHK_SHOW_GEOMETRY, OnChkShowGeometry)
	ON_BN_CLICKED(IDC_BTN_LOAD_GEOMETRY, OnBtnLoadGeometry)
	ON_BN_CLICKED(IDC_BTN_REMOVE_OBJECT, OnBtnRemoveObject)
	ON_BN_CLICKED(IDC_BTN_ADD_OBJECT, OnBtnAddObject)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDlgObjectSettings::OnCancel()
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;
	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	
	TRACE("CDlgObjectSettings::OnCancel()\n");	

//	KillTimer(ID_UPDATETIMER_OBJECT_SETTINGS);
	m_bIsActive=false;
	
	UpdateData(true);
	
	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgObjectSettings::OnOK()
{	//Ohne Inhalt da Return nicht als Abbruch fr Fenster benutzt wird.
	//Wenn OnOK() nicht berschrieben wird, dann wird dennoch die standart OnOK()-Version ausgefhrt.
	OnBtnUpdate();
}

BOOL CDlgObjectSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
//	SetTimer(ID_UPDATETIMER_OBJECT_SETTINGS,100,NULL);
	
	COpenGLObject* pObject;
	POSITION pos=COpenGLObject::m_pObjectList.GetHeadPosition();
	while (pos)
	{	pObject=COpenGLObject::m_pObjectList.GetNext(pos);
		m_ctlObjectList.AddString(pObject->GetName());	
	};
	m_ctlObjectList.SetCurSel(0);

	UpdateData(false);	
	UpdateData(true);	

	UpdateDlg();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgObjectSettings::UpdateDlg()
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	COpenGLObject* pObject;
	UpdateData(true);
	
	bool doit_a=false;	// passives Object -> alle mgl.
	bool doit_b=false;	// gesteuertes object -> pos/orient bernimmt andere fkt
	pObject=COpenGLObject::GetObject(m_strObjectList);
	
	if (pObject) doit_a=true;
	if (pObject->GetStatus()=="passiv") doit_b=true;
//	doit_b=true;

	GetDlgItem(IDC_OBJECT_LIST)->EnableWindow(doit_a);
	
	GetDlgItem(IDC_EDIT_POS+0)->EnableWindow(doit_b);
	GetDlgItem(IDC_EDIT_POS+1)->EnableWindow(doit_b);
	GetDlgItem(IDC_EDIT_POS+2)->EnableWindow(doit_b);
	
	GetDlgItem(IDC_EDIT_OFFSET+0)->EnableWindow(doit_a);
	GetDlgItem(IDC_EDIT_OFFSET+1)->EnableWindow(doit_a);
	GetDlgItem(IDC_EDIT_OFFSET+2)->EnableWindow(doit_a);
	
	GetDlgItem(IDC_EDIT_ORIENTATION+0)->EnableWindow(doit_b);	
	GetDlgItem(IDC_EDIT_ORIENTATION+1)->EnableWindow(doit_b);	
	GetDlgItem(IDC_EDIT_ORIENTATION+2)->EnableWindow(doit_b);	
	
	GetDlgItem(IDC_EDIT_OFFSETO+0)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_OFFSETO+1)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_OFFSETO+2)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_COLOR+0)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_COLOR+1)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_COLOR+2)->EnableWindow(doit_a);	
	GetDlgItem(IDC_EDIT_COLOR+3)->EnableWindow(doit_a);	
	
	GetDlgItem(IDC_CHK_SHOW_ORIGIN)->EnableWindow(doit_a);	
	GetDlgItem(IDC_CHK_SHOW_GEOMETRY)->EnableWindow(doit_a);	
	
	GetDlgItem(IDC_EDIT_GEOMETRY_PATH)->EnableWindow(doit_a);	
	GetDlgItem(IDC_BTN_LOAD_GEOMETRY)->EnableWindow(doit_a);	
	GetDlgItem(IDC_BTN_UPDATE)->EnableWindow(doit_a);	
	GetDlgItem(IDC_BTN_REMOVE_OBJECT)->EnableWindow(doit_b);	
	//GetDlgItem(IDC_BTN_ADD_OBJECT)->EnableWindow(doit_b);	

	if (pObject) 
	{	pObject->GetPosition(m_dPos);
		Round(m_dPos,2);
	
		pObject->GetPositionOffset(m_dPosOffset);
		Round(m_dPosOffset,2);
	
		pObject->GetOrientation(m_dOrientation);
		Round(m_dOrientation,2);

		pObject->GetOrientationOffset(m_dOrientationOffset);
		Round(m_dOrientationOffset,2);
	
		pObject->GetColor(m_dColor);
		Round(m_dColor,1,4);

		m_bShowOrigin=pObject->GetShowOrigin();
		m_bShowGeometry=pObject->GetShowGeometry();

		m_strGeometrieFile=pObject->GetGeometrieFile();
		UpdateData(false);
	};

	pOpenGL->DrawScene();

}

void CDlgObjectSettings::OnSelchangeObjectList() 
{	UpdateData(true);
	UpdateDlg();
}

void CDlgObjectSettings::OnBtnUpdate() 
{	//COpenGLScene* pScene =  COpenGLFunctions::m_pCOpenGLFunctions->m_Scene;
	//COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLObject* pObject;
	UpdateData(true);

	pObject=COpenGLObject::GetObject(m_strObjectList);

	pObject->SetPosition(m_dPos);
	pObject->SetPositionOffset(m_dPosOffset);
	pObject->SetOrientation(m_dOrientation);
	pObject->SetOrientationOffset(m_dOrientationOffset);
	pObject->SetColor(m_dColor);

	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgObjectSettings::OnChkShowOrigin() 
{
	COpenGLObject* pObject;
	pObject=COpenGLObject::GetObject(m_strObjectList);
	UpdateData(true);
	pObject->SetShowOrigin(m_bShowOrigin>0);
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();

}

void CDlgObjectSettings::OnChkShowGeometry() 
{
	COpenGLObject* pObject;
	pObject=COpenGLObject::GetObject(m_strObjectList);
	UpdateData(true);
	pObject->SetShowGeometrie(m_bShowGeometry>0);
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();

}

void CDlgObjectSettings::OnBtnLoadGeometry() 
{	COpenGLObject* pObject;
	UpdateData(true);
	pObject=COpenGLObject::GetObject(m_strObjectList);
	pObject->SetGeometrie(m_strGeometrieFile);	
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgObjectSettings::OnBtnRemoveObject() 
{	COpenGLObject* pObject;
	CIniFile* INI = CIniFile::m_pCIniFile;
	UpdateData(true);
	
	int iResults;
	iResults = MessageBox(	"Wollen Sie das Objekt \""+m_strObjectList+"\" wirklich entfernen?\n\n"+
				"Dieser Vorgang kann nicht rckgngig gemacht werden.\n"+
				"Alle gespeicherten Einstellungen gehen komplett verloren.\n"+
				"Zur Sicherheit knnen Sie jedoch zuvor eine Kopie der HexMotion.ini machen.",
				"Objekt \""+m_strObjectList+"\" entfernen?",
				MB_YESNOCANCEL | MB_ICONINFORMATION);
	if (iResults==IDYES)
	{	pObject=COpenGLObject::GetObject(m_strObjectList);
		INI->DeleteKey(pObject->GetName());
		delete(pObject);

		CString strDeleteName=m_strObjectList;
		int index=m_ctlObjectList.FindString(0,strDeleteName);
		m_ctlObjectList.DeleteString(index);
		m_ctlObjectList.SetCurSel(0);
	};

	UpdateData(false);	
	UpdateData(true);	
	
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgObjectSettings::OnBtnAddObject() 
{	COpenGLObject* pObject;
	CString strName;
	if (m_DlgObjectAdd.DoModal () == IDOK)
		{	strName = m_DlgObjectAdd.m_strObjectName;
			if (strName.GetLength()>0)
			{	pObject = new COpenGLObject(strName);
				static const float v[3]={0};
				pObject ->SetPositionOffset(v);
				pObject ->SetOrientationOffset(v);
				pObject ->SetPosition(v);
				pObject ->SetOrientation(v);
				pObject ->SetColor(0.5f,0.5f,0.5f,1.0f);
		
				pObject ->SetShowGeometrie(false);
				pObject ->SetShowOrigin(true);
		
				m_ctlObjectList.AddString(strName);
				m_ctlObjectList.SetCurSel(m_ctlObjectList.FindString(0,strName));
			};
			UpdateData(true);	
		};
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}
