// DlgSceneNavigation.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "resource.h"
#include "OpenGLScene.h"
#include "OpenGLFunctions.h"
#include "DlgSceneNavigation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgSceneNavigation 


CDlgSceneNavigation::CDlgSceneNavigation(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSceneNavigation::IDD, pParent)
{	m_bIsActive=false;
	//{{AFX_DATA_INIT(CDlgSceneNavigation)
	m_nSelectA = -1;
	//}}AFX_DATA_INIT
}


void CDlgSceneNavigation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSceneNavigation)
	DDX_Radio(pDX, IDC_CHK_MU_SCENE_TRANSLATE, m_nSelectA);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSceneNavigation, CDialog)
	ON_COMMAND_RANGE (IDC_CHK_MU_SCENE_TRANSLATE, IDC_CHK_MU_SCENE_ROTATE, OnChange)	
	ON_COMMAND_RANGE (IDC_BTN_USE_VP_A, IDC_BTN_USE_VP_D, OnBtnUseViewPoint)
	ON_COMMAND_RANGE (IDC_BTN_SET_VP_A, IDC_BTN_SET_VP_D, OnBtnSetViewPoint)
	ON_COMMAND_RANGE (IDC_BTN_USE_VP_1, IDC_BTN_USE_VP_8, OnBtnStdViewPoint)
	
	//{{AFX_MSG_MAP(CDlgSceneNavigation)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgSceneNavigation 

BOOL CDlgSceneNavigation::OnInitDialog() 
{
	SetTimer(ID_UPDATETIMER_SCENE_NAVIGATION,100,NULL);
	CDialog::OnInitDialog();
	UpdateDlg();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgSceneNavigation::OnCancel()
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	CIniFile* INI = CIniFile::m_pCIniFile;
	
	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	//TRACE("CDlgNavigation::OnCancel()\n");
	KillTimer(ID_UPDATETIMER_SCENE_NAVIGATION);
	m_bIsActive=false;
	
	float temp[3];
	int n;
	int nVP;
	CString KEY;
	for (nVP=0;nVP<=3;nVP++)
	{	if (nVP==0) KEY="SCENE_VP_A";
		if (nVP==1) KEY="SCENE_VP_B";
		if (nVP==2) KEY="SCENE_VP_C";
		if (nVP==3) KEY="SCENE_VP_D";
		for (n=0;n<3;n++) temp[n]=pScene->m_fViewPoint[nVP][n];
		INI->SetValue(KEY,"viewposition",temp,true);
		for (n=0;n<3;n++) temp[n]=pScene->m_fViewPoint[nVP][n+3];
		INI->SetValue(KEY,"sceneangle",temp,true);
		for (n=0;n<3;n++) temp[n]=pScene->m_fViewPoint[nVP][n+6];
		INI->SetValue(KEY,"sceneposition",temp,true);
	};

	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgSceneNavigation::OnOK()
{	//Ohne Inhalt da Return nicht als Abbruch fr Fenster benutzt wird.
	//Wenn OnOK() nicht berschrieben wird, dann wird dennoch die standart OnOK()-Version ausgefhrt.
	OnCancel();
}



void CDlgSceneNavigation::UpdateDlg()
{
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	m_nSelectA=-1;
	if (pScene->m_nMouseUsage==MU_SCENE_TRANSLATE)		m_nSelectA=0;
	if (pScene->m_nMouseUsage==MU_SCENE_TRANSLATE_INTO)	m_nSelectA=1;
	if (pScene->m_nMouseUsage==MU_SCENE_ROTATE)			m_nSelectA=2;

	UpdateData(false);
}

void CDlgSceneNavigation::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{	
	case ID_UPDATETIMER_SCENE_NAVIGATION:
		UpdateDlg();
		break;
	};	
	CDialog::OnTimer(nIDEvent);
}

void CDlgSceneNavigation::OnChange(UINT unusedVar) //changing by S.Wei 06.08.2007
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;

	UpdateData(true);
	if (m_nSelectA==0) pScene->m_nMouseUsage=MU_SCENE_TRANSLATE;
	if (m_nSelectA==1) pScene->m_nMouseUsage=MU_SCENE_TRANSLATE_INTO;
	if (m_nSelectA==2) pScene->m_nMouseUsage=MU_SCENE_ROTATE;
	pOpenGL->DrawScene();
}

void CDlgSceneNavigation::OnBtnUseViewPoint(UINT nCmdID)
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	
	int n=-1;
	switch(nCmdID)
	{	case IDC_BTN_USE_VP_A:
			n=0;		break;
		case IDC_BTN_USE_VP_B:
			n=1;		break;
		case IDC_BTN_USE_VP_C:
			n=2;		break;
		case IDC_BTN_USE_VP_D:
			n=3;		break;
	};
	if (n>=0)
	{
		pScene->m_fViewPosition[0]	=pScene->m_fViewPoint[n][0];
		pScene->m_fViewPosition[1]	=pScene->m_fViewPoint[n][1];
		pScene->m_fViewPosition[2]	=pScene->m_fViewPoint[n][2];
		pScene->m_fSceneAngle[0]	=pScene->m_fViewPoint[n][3];
		pScene->m_fSceneAngle[1]	=pScene->m_fViewPoint[n][4];
		pScene->m_fSceneAngle[2]	=pScene->m_fViewPoint[n][5];
		pScene->m_fScenePosition[0]	=pScene->m_fViewPoint[n][6];
		pScene->m_fScenePosition[1]	=pScene->m_fViewPoint[n][7];
		pScene->m_fScenePosition[2]	=pScene->m_fViewPoint[n][8];
		pOpenGL->DrawScene();
	};
}

void CDlgSceneNavigation::OnBtnStdViewPoint(UINT nCmdID)
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	
			pScene->m_fViewPosition[0]	=0.0f;
			pScene->m_fViewPosition[1]	=0.0f;
			pScene->m_fViewPosition[2]	=30.0f;
			pScene->m_fScenePosition[0]	=0.0f;
			pScene->m_fScenePosition[1]	=0.0f;
			pScene->m_fScenePosition[2]	=0.0f;
	switch(nCmdID)
	{	case IDC_BTN_USE_VP_1:
			pScene->m_fSceneAngle[0]	=0.0f;
			pScene->m_fSceneAngle[1]	=0.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_2:
			pScene->m_fSceneAngle[0]	=180.0f;
			pScene->m_fSceneAngle[1]	=0.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_3:
			pScene->m_fSceneAngle[0]	=90.0f;
			pScene->m_fSceneAngle[1]	=0.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_4:
			pScene->m_fSceneAngle[0]	=270.0f;
			pScene->m_fSceneAngle[1]	=0.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_5:
			pScene->m_fSceneAngle[0]	=0.0f;
			pScene->m_fSceneAngle[1]	=90.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_6:
			pScene->m_fSceneAngle[0]	=0.0f;
			pScene->m_fSceneAngle[1]	=-90.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_7:
			pScene->m_fSceneAngle[0]	=-45.0f;
			pScene->m_fSceneAngle[1]	=45.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
		case IDC_BTN_USE_VP_8:
			pScene->m_fSceneAngle[0]	=-30.0f;
			pScene->m_fSceneAngle[1]	=30.0f;
			pScene->m_fSceneAngle[2]	=0.0f;
			break;
	};
	pOpenGL->DrawScene();
}

void CDlgSceneNavigation::OnBtnSetViewPoint(UINT nCmdID)
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	
	int n=-1;
	switch(nCmdID)
	{	case IDC_BTN_SET_VP_A: 	
			n=0;		break;
		case IDC_BTN_SET_VP_B:
			n=1;		break;
		case IDC_BTN_SET_VP_C:
			n=2;		break;
		case IDC_BTN_SET_VP_D:
			n=3;		break;
	};
	if (n>=0)
	{	pScene->m_fViewPoint[n][0]=pScene->m_fViewPosition[0];
		pScene->m_fViewPoint[n][1]=pScene->m_fViewPosition[1];
		pScene->m_fViewPoint[n][2]=pScene->m_fViewPosition[2];
		pScene->m_fViewPoint[n][3]=pScene->m_fSceneAngle[0];
		pScene->m_fViewPoint[n][4]=pScene->m_fSceneAngle[1];
		pScene->m_fViewPoint[n][5]=pScene->m_fSceneAngle[2];
		pScene->m_fViewPoint[n][6]=pScene->m_fScenePosition[0];
		pScene->m_fViewPoint[n][7]=pScene->m_fScenePosition[1];
		pScene->m_fViewPoint[n][8]=pScene->m_fScenePosition[2];
	};
}

