// DlgSceneSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "resource.h"
#include "OpenGLScene.h"
#include "OpenGLFunctions.h"
#include "DlgSceneSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgSceneSettings 


CDlgSceneSettings::CDlgSceneSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSceneSettings::IDD, pParent)
{	m_bIsActive=false;
	//{{AFX_DATA_INIT(CDlgSceneSettings)
	m_bShowGrid_XY = FALSE;
	m_bShowGrid_XZ = FALSE;
	m_bShowGrid_YZ = FALSE;
	m_nSlider0 = 0;
	m_nSlider1 = 0;
	m_nSlider2 = 0;
	m_bShowGlobalOrigin = FALSE;
	m_bShowSceneOrigin = FALSE;
	m_strColorList = _T("");
	m_bShowMarkers = FALSE;
	m_bShowServoDebug = FALSE;
	m_bShowPlattformDebug = FALSE;
	m_bShowLinkDebug = FALSE;
	//}}AFX_DATA_INIT
}


void CDlgSceneSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSceneSettings)
	DDX_Control(pDX, IDC_COLOR_LIST, m_ctlColorList);
	DDX_Control(pDX, IDC_SLIDER2, m_ctlSlider2);
	DDX_Control(pDX, IDC_SLIDER1, m_ctlSlider1);
	DDX_Control(pDX, IDC_SLIDER0, m_ctlSlider0);
	DDX_Check(pDX, IDC_CHK_SHOWGRID_XY, m_bShowGrid_XY);
	DDX_Check(pDX, IDC_CHK_SHOWGRID_XZ, m_bShowGrid_XZ);
	DDX_Check(pDX, IDC_CHK_SHOWGRID_YZ, m_bShowGrid_YZ);
	DDX_Slider(pDX, IDC_SLIDER0, m_nSlider0);
	DDX_Slider(pDX, IDC_SLIDER1, m_nSlider1);
	DDX_Slider(pDX, IDC_SLIDER2, m_nSlider2);
	DDX_CBString(pDX, IDC_COLOR_LIST, m_strColorList);
	DDX_Check(pDX, IDC_CHK_SHOWMARKERS, m_bShowMarkers);
	DDX_Check(pDX, IDC_CHK_SHOW_SERVO_DEBUG, m_bShowServoDebug);
	DDX_Check(pDX, IDC_CHK_SHOW_PLATTFORM_DEBUG, m_bShowPlattformDebug);
	DDX_Check(pDX, IDC_CHK_SHOW_LINK_DEBUG, m_bShowLinkDebug);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSceneSettings, CDialog)
	ON_COMMAND_RANGE (IDC_CHK_SHOWGRID_XY, IDC_CHK_SHOW_LINK_DEBUG, OnChangeSettings)
	//{{AFX_MSG_MAP(CDlgSceneSettings)
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COLOR_LIST, OnSelchangeColorList)
	ON_CBN_DROPDOWN(IDC_COLOR_LIST, OnDropdownColorList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgSceneSettings 

void CDlgSceneSettings::OnCancel()
{	
	COpenGLScene* pScene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;
	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	TRACE("CDlgSceneSettings::OnCancel()\n");
	KillTimer(ID_UPDATETIMER_SCENE_SETTINGS);
	m_bIsActive=false;
	
	UpdateData(true);
	
	CIniFile::m_pCIniFile->SetValue("SCENE","grid_xz_show",(int)m_bShowGrid_XZ);
	CIniFile::m_pCIniFile->SetValue("SCENE","grid_xy_show",(int)m_bShowGrid_XY);
	CIniFile::m_pCIniFile->SetValue("SCENE","grid_yz_show",(int)m_bShowGrid_YZ);
	CIniFile::m_pCIniFile->SetValue("SCENE","plattform_debug",(int)m_bShowPlattformDebug,true);
	CIniFile::m_pCIniFile->SetValue("SCENE","servo_debug",(int)m_bShowServoDebug,true);
	CIniFile::m_pCIniFile->SetValue("SCENE","link_debug",(int)m_bShowLinkDebug,true);

	CIniFile::m_pCIniFile->SetValue("SCENE","grid_xz_color",pScene->m_fColor_Grid[0],true);
	CIniFile::m_pCIniFile->SetValue("SCENE","grid_xy_color",pScene->m_fColor_Grid[1],true);
	CIniFile::m_pCIniFile->SetValue("SCENE","grid_yz_color",pScene->m_fColor_Grid[2],true);

	


	CIniFile::m_pCIniFile->SetValue("SCENE","markers_show",(int)m_bShowMarkers);
	CIniFile::m_pCIniFile->SetValue("SCENE","markers_color",pScene->m_fColor_Markers,true);

	CIniFile::m_pCIniFile->SetValue("SCENE","background_color",pScene->m_fColor_SceneBackground,true);
	
	pScene->m_bShowAllMarkers=false;
	
	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
	
}

void CDlgSceneSettings::OnOK()
{	//Ohne Inhalt da Return nicht als Abbruch fr Fenster benutzt wird.
	//Wenn OnOK() nicht berschrieben wird, dann wird dennoch die standart OnOK()-Version ausgefhrt.
	OnCancel();
}

BOOL CDlgSceneSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetTimer(ID_UPDATETIMER_SCENE_SETTINGS,100,NULL);
	m_ctlColorList.SetCurSel(0);
	UpdateData(false);	
	UpdateData(true);	

	UpdateDlg();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgSceneSettings::UpdateDlg()
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	
	m_bShowGrid_XY=(pScene->m_nShowSettings & SHOW_GRID_XY)>0;
	m_bShowGrid_XZ=(pScene->m_nShowSettings & SHOW_GRID_XZ)>0;
	m_bShowGrid_YZ=(pScene->m_nShowSettings & SHOW_GRID_YZ)>0;
	m_bShowMarkers=(pScene->m_nShowSettings & SHOW_MARKERS)>0;

	m_bShowPlattformDebug=(pScene->m_nShowSettings & SHOW_PLATTFORM_DEBUG)>0;
	m_bShowServoDebug=(pScene->m_nShowSettings & SHOW_SERVO_DEBUG)>0;
	m_bShowLinkDebug=(pScene->m_nShowSettings & SHOW_LINK_DEBUG)>0;

	

//	m_bShowGlobalOrigin=pScene->m_nShowSettings & SHOW_SCENEORIGIN;
//	m_bShowSceneOrigin=pScene->m_nShowSettings & SHOW_GLOBALORIGIN;

	int nSliderMin=0;
	int nSliderMax=100;
	int nSliderPos[3]={0,0,0};
	pScene->m_bShowAllMarkers=false;
	if (m_strColorList=="Szenenhintergrund")
	{	nSliderPos[0] = (int) (pScene->m_fColor_SceneBackground[0]*100);
		nSliderPos[1] = (int) (pScene->m_fColor_SceneBackground[1]*100);
		nSliderPos[2] = (int) (pScene->m_fColor_SceneBackground[2]*100);
	} else 
	if (m_strColorList=="Navigationsmarker")
	{	pScene->m_bShowAllMarkers=true;
		nSliderPos[0] = (int) (pScene->m_fColor_Markers[0]*100);
		nSliderPos[1] = (int) (pScene->m_fColor_Markers[1]*100);
		nSliderPos[2] = (int) (pScene->m_fColor_Markers[2]*100);
	} else
	if (m_strColorList=="Gitternetz_XZ")
	{	nSliderPos[0] = (int) (pScene->m_fColor_Grid[0][0]*100);
		nSliderPos[1] = (int) (pScene->m_fColor_Grid[0][1]*100);
		nSliderPos[2] = (int) (pScene->m_fColor_Grid[0][2]*100);
	} else
	if (m_strColorList=="Gitternetz_XY")
	{	nSliderPos[0] = (int) (pScene->m_fColor_Grid[1][0]*100);
		nSliderPos[1] = (int) (pScene->m_fColor_Grid[1][1]*100);
		nSliderPos[2] = (int) (pScene->m_fColor_Grid[1][2]*100);
	} else
	if (m_strColorList=="Gitternetz_YZ")
	{	nSliderPos[0] = (int) (pScene->m_fColor_Grid[2][0]*100);
		nSliderPos[1] = (int) (pScene->m_fColor_Grid[2][1]*100);
		nSliderPos[2] = (int) (pScene->m_fColor_Grid[2][2]*100);
	}
	pOpenGL->DrawScene();
	UpdateData(false);
	
	m_ctlSlider0.SetRange(nSliderMin,nSliderMax);
	m_ctlSlider0.SetPos(nSliderPos[0]);
	
	m_ctlSlider1.SetRange(nSliderMin,nSliderMax);
	m_ctlSlider1.SetPos(nSliderPos[1]);
	
	m_ctlSlider2.SetRange(nSliderMin,nSliderMax);
	m_ctlSlider2.SetPos(nSliderPos[2]);

	UpdateData(true);
}

void CDlgSceneSettings::OnChangeSettings(UINT nCmdID)
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	
	UpdateData(true);	
	switch (nCmdID)
	{	case IDC_CHK_SHOWGRID_XY:
			if (m_bShowGrid_XY)	pScene->m_nShowSettings |= SHOW_GRID_XY;
			else pScene->m_nShowSettings &= ~SHOW_GRID_XY;
			break;
		case IDC_CHK_SHOWGRID_XZ:
			if (m_bShowGrid_XZ)	pScene->m_nShowSettings |= SHOW_GRID_XZ;
			else pScene->m_nShowSettings &= ~SHOW_GRID_XZ;
			break;
		case IDC_CHK_SHOWGRID_YZ:
			if (m_bShowGrid_YZ)	pScene->m_nShowSettings |= SHOW_GRID_YZ;
			else pScene->m_nShowSettings &= ~SHOW_GRID_YZ;
			break;
		case IDC_CHK_SHOWMARKERS:
			if (m_bShowMarkers)	pScene->m_nShowSettings |= SHOW_MARKERS;
			else pScene->m_nShowSettings &= ~SHOW_MARKERS;
			break;
		case IDC_CHK_SHOW_SERVO_DEBUG:
			if (m_bShowServoDebug)	pScene->m_nShowSettings |= SHOW_SERVO_DEBUG;
			else pScene->m_nShowSettings &= ~SHOW_SERVO_DEBUG;
			break;
		case IDC_CHK_SHOW_PLATTFORM_DEBUG:
			if (m_bShowPlattformDebug)	pScene->m_nShowSettings |= SHOW_PLATTFORM_DEBUG;
			else pScene->m_nShowSettings &= ~SHOW_PLATTFORM_DEBUG;
			break;
		case IDC_CHK_SHOW_LINK_DEBUG:
			if (m_bShowLinkDebug)	pScene->m_nShowSettings |= SHOW_LINK_DEBUG;
			else pScene->m_nShowSettings &= ~SHOW_LINK_DEBUG;
			break;

	};
	pOpenGL->DrawScene();
}

void CDlgSceneSettings::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	COpenGLScene* pScene = pOpenGL->m_pScene;
	UpdateData(true);
	
	switch (pScrollBar->GetDlgCtrlID())	
	{
	case IDC_SLIDER0:
		if (m_strColorList=="Szenenhintergrund")	pScene->m_fColor_SceneBackground[0]=	m_nSlider0/100.0f;
		if (m_strColorList=="Navigationsmarker"){	pScene->m_fColor_Markers[0]=			m_nSlider0/100.0f;pScene->InitMarkers();};
		if (m_strColorList=="Gitternetz_XZ"){		pScene->m_fColor_Grid[0][0]=			m_nSlider0/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_XY"){		pScene->m_fColor_Grid[1][0]=			m_nSlider0/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_YZ"){		pScene->m_fColor_Grid[2][0]=			m_nSlider0/100.0f;pScene->InitGrids();};
		break;
	case IDC_SLIDER1:
		if (m_strColorList=="Szenenhintergrund")	pScene->m_fColor_SceneBackground[1]=	m_nSlider1/100.0f;
		if (m_strColorList=="Navigationsmarker"){	pScene->m_fColor_Markers[1]=			m_nSlider1/100.0f;pScene->InitMarkers();};
		if (m_strColorList=="Gitternetz_XZ"){		pScene->m_fColor_Grid[0][1]=			m_nSlider1/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_XY"){		pScene->m_fColor_Grid[1][1]=			m_nSlider1/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_YZ"){		pScene->m_fColor_Grid[2][1]=			m_nSlider1/100.0f;pScene->InitGrids();};
		break;
	case IDC_SLIDER2:
		if (m_strColorList=="Szenenhintergrund")	pScene->m_fColor_SceneBackground[2]=	m_nSlider2/100.0f;
		if (m_strColorList=="Navigationsmarker"){	pScene->m_fColor_Markers[2]=			m_nSlider2/100.0f;pScene->InitMarkers();};
		if (m_strColorList=="Gitternetz_XZ"){		pScene->m_fColor_Grid[0][2]=			m_nSlider2/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_XY"){		pScene->m_fColor_Grid[1][2]=			m_nSlider2/100.0f;pScene->InitGrids();};
		if (m_strColorList=="Gitternetz_YZ"){		pScene->m_fColor_Grid[2][2]=			m_nSlider2/100.0f;pScene->InitGrids();};
		break;
	};
	pOpenGL->DrawScene();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDlgSceneSettings::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{	
	case ID_UPDATETIMER_SCENE_SETTINGS:
		//Beep(1000,100);
		UpdateDlg();
		break;
	};	
	CDialog::OnTimer(nIDEvent);
}

void CDlgSceneSettings::OnSelchangeColorList() 
{	UpdateData(true);
	UpdateDlg();
	SetTimer(ID_UPDATETIMER_SCENE_SETTINGS,100,NULL);
}

void CDlgSceneSettings::OnDropdownColorList() 
{	KillTimer(ID_UPDATETIMER_SCENE_SETTINGS);
}


