// DlgServoSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "IniFile.h"
#include "Servo.h"
#include "OpenGLScene.h"
#include "OpenGLObject.h"
#include "OpenGLFunctions.h"
#include "DlgServoSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgServoSettings 


CDlgServoSettings::CDlgServoSettings(CWnd* pParent /*=NULL*/)
 : CDialog(CDlgServoSettings::IDD, pParent) {
 ZeroMemory(&m_dServoAngle,sizeof(float)*11);
	//{{AFX_DATA_INIT(CDlgServoSettings)
 m_nUsedAngle = -1;
	//}}AFX_DATA_INIT
/*	m_bIsActive=false;
	m_strServoList = _T("");
	m_dServoAngle = 0.0;
	m_dServoOrientation_A = 0.0;
	m_dServoOrientation_B = 0.0;
	m_dServoOrientation_C = 0.0;
	m_dServoPosition_X = 0.0;
	m_dServoPosition_Y = 0.0;
	m_dServoPosition_Z = 0.0;
	m_dServoStartAngle = 0.0;
	m_dServoArmLength = 0.0;
	m_dServoLinkLength = 0.0;
	m_dServoAngleCorrection = 0.0;
*/
}


void CDlgServoSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgServoSettings)
	DDX_Control(pDX, IDC_SERVO_LIST, m_ctlServoList);
	DDX_CBString(pDX, IDC_SERVO_LIST, m_strServoList);
	DDX_Text(pDX, IDC_EDIT_SERVO_ANGLE, m_dServoAngle);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+3, m_dServoOrientation[0]);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+4, m_dServoOrientation[1]);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+5, m_dServoOrientation[2]);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+0, m_dServoPosition[0]);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+1, m_dServoPosition[1]);
	DDX_Text(pDX, IDC_EDIT_SERVO_POS+2, m_dServoPosition[2]);
	DDX_Text(pDX, IDC_EDIT_SERVO_STARTANGLE, m_dServoStartAngle);
	DDX_Text(pDX, IDC_EDIT_SERVO_ARMLENGTH, m_dServoArmLength);
	DDX_Radio(pDX, IDC_USEDANGLE_1, m_nUsedAngle);
	DDX_Text(pDX, IDC_EDIT_SERVO_LINKLENGTH, m_dServoLinkLength);
	DDX_Text(pDX, IDC_EDIT_SERVO_ANGLECORRECTION, m_dServoAngleCorrection);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgServoSettings, CDialog)
	//{{AFX_MSG_MAP(CDlgServoSettings)
	ON_CBN_SELCHANGE(IDC_SERVO_LIST, OnSelchangeServoList)
	ON_BN_CLICKED(IDC_BTN_SERVO_UPDATE, OnBtnServoUpdate)
	ON_BN_CLICKED(IDC_USEDANGLE_1, OnChangeUsedAngle)
	ON_BN_CLICKED(IDC_USEDANGLE_2, OnChangeUsedAngle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDlgServoSettings::UpdateDlg()
{	
	COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	CServo* pServo;
	UpdateData(true);
	pServo=CServo::GetServo(m_strServoList);
	
	bool doit=false;
	if (pServo) doit=true;
	if (pServo)	
	{
		pServo->GetPosition(m_dServoPosition);
		Round(m_dServoPosition,2);
		pServo->GetOrientation(m_dServoOrientation);
		Round(m_dServoOrientation,2);
		
		m_dServoAngle=pServo->GetAngle();
		m_dServoStartAngle=pServo->GetStartAngle();
		m_dServoArmLength=pServo->GetArmLength();
		m_dServoLinkLength=pServo->GetLinkLength();
		m_dServoAngleCorrection=pServo->GetAngleCorrectionFactor();
		m_nUsedAngle=pServo->GetUsedAngle()-1;
	};
	UpdateData(false);
	

	GetDlgItem(IDC_SERVO_LIST)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+0)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+1)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+2)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+3)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+4)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_POS+5)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_ANGLE)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_STARTANGLE)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_ARMLENGTH)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_LINKLENGTH)->EnableWindow(doit);	
	GetDlgItem(IDC_EDIT_SERVO_ANGLECORRECTION)->EnableWindow(doit);	
	GetDlgItem(IDC_USEDANGLE_1)->EnableWindow(doit);	
	GetDlgItem(IDC_USEDANGLE_2)->EnableWindow(doit);	
	GetDlgItem(IDC_BTN_SERVO_UPDATE)->EnableWindow(doit);	

	pOpenGL->DrawScene();

}

BOOL CDlgServoSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CServo* pServo;
	
	POSITION pos=CServo::m_pServoList.GetHeadPosition();
	while (pos)
	{	pServo=CServo::m_pServoList.GetNext(pos);
		m_ctlServoList.AddString(pServo->GetName());	
	};
	m_ctlServoList.SetCurSel(0);

	UpdateData(true);	

	UpdateDlg();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgServoSettings::OnOK()
{
	OnBtnServoUpdate();
}

void CDlgServoSettings::OnCancel()
{
	CIniFile* INI = CIniFile::m_pCIniFile;

	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	TRACE("CDlgServoSettings::OnCancel()\n");	

	m_bIsActive=false;
	
	UpdateData(true);
	
	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CDlgServoSettings::OnBtnServoUpdate() 
{
	CServo* pServo;
	UpdateData(true);

	pServo=CServo::GetServo(m_strServoList);

	if (pServo != NULL)
	{	pServo->SetPosition(m_dServoPosition);
		pServo->SetOrientation(m_dServoOrientation);
		pServo->SetStartAngle(m_dServoStartAngle);
		pServo->SetArmLength(m_dServoArmLength);
		pServo->SetLinkLength(m_dServoLinkLength);
		pServo->SetAngle(m_dServoAngle);
		pServo->SetAngleCorrectionFactor(m_dServoAngleCorrection);
		pServo->CalcConnection();
	};
	
	UpdateDlg();
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();	
}

void CDlgServoSettings::OnSelchangeServoList() 
{
	UpdateData(true);
	UpdateDlg();	
}

void CDlgServoSettings::OnChangeUsedAngle() 
{
	CServo* pServo;
	UpdateData(true);
	
	pServo=CServo::GetServo(m_strServoList);
	if (pServo) 
	{
		pServo->SetUsedAngle(m_nUsedAngle+1);
		pServo->CalcConnection();
	}
	
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
	UpdateDlg();

}
