// DlgStrgServoTester.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "hexmotion.h"
#include "Servo.h"
#include "OpenGLFunctions.h"
#include "DlgStrgServoTester.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgStrgServoTester 


CDlgStrgServoTester::CDlgStrgServoTester(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgStrgServoTester::IDD, pParent)
{	m_bIsActive=false;
	//{{AFX_DATA_INIT(CDlgStrgServoTester)
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CDlgStrgServoTester, CDialog)
	//{{AFX_MSG_MAP(CDlgStrgServoTester)
	ON_WM_VSCROLL()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_CONNECT, OnBtnConnect)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
//	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER0, &CDlgStrgServoTester::OnNMCustomdrawSlider0)
END_MESSAGE_MAP()

bool GetServoPos(int idx, int*val) {
 CServo* pServo = CServo::GetServo(idx+1);
 if (!pServo) return false;
 if (val) *val = (int)pServo->GetAngle();
 return true;
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgStrgServoTester

BOOL CDlgStrgServoTester::OnInitDialog() {
 SetTimer(ID_UPDATETIMER_STRG_SERVOTESTER,300,NULL);
 CDialog::OnInitDialog();
 UpdateDlg();
 for (int i=0; i<6; i++) {
  SendDlgItemMessage(IDC_SLIDER0+i,TBM_SETRANGE,FALSE,MAKELONG(0,190));
  SendDlgItemMessage(IDC_SLIDER0+i,TBM_SETPAGESIZE,0,10);
  int p = 95;
  GetServoPos(i,&p);
  SetDlgItemInt(IDC_SHOW_SLIDER0+i,p);		// initialisieren
  if (i&1) p = 190-p;		// strzen
  SendDlgItemMessage(IDC_SLIDER0+i,TBM_SETPOS,TRUE,p);
 }
 return TRUE;
}

void CDlgStrgServoTester::UpdateDlg() {
 bool conn = gApp.m_SerialCom.IsConnected();
 if (conn) SetTimer(ID_RECEIVETIMER,100,NULL);
 SetDlgItemText(IDC_CONNECTION_STATE2,conn ? "verbunden mit "+gApp.m_SerialCom.GetName() : "nicht verbunden");
 SetDlgItemText(IDC_BTN_CONNECT,conn ? "Trennen" : "Verbinden");
 for (int i=0; i<6; i++) {
  GetDlgItem(IDC_SLIDER0+i)->EnableWindow(conn);
  GetDlgItem(IDC_SHOW_SLIDER0+i)->EnableWindow(conn);
  GetDlgItem(IDC_NR_SLIDER0+i)->EnableWindow(conn);
  int q = GetDlgItemInt(IDC_SHOW_SLIDER0+i);
  int p;
  if (GetServoPos(i,&p) && p!=q) {	// nderung anzeigen
   SetDlgItemInt(IDC_SHOW_SLIDER0+i,p);
   if (i&1) p = 190-p;		// strzen
   SendDlgItemMessage(IDC_SLIDER0+i,TBM_SETPOS,TRUE,p);
  }
 }
}

void CDlgStrgServoTester::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
 switch (nSBCode) {
  case SB_LINEDOWN:
  case SB_LINEUP:
  case SB_PAGEDOWN:
  case SB_PAGEUP: {
   nPos = pScrollBar->SendMessage(TBM_GETPOS);
  }/*nobreak;*/
  case SB_THUMBTRACK: {
   unsigned i = pScrollBar->GetDlgCtrlID() - IDC_SLIDER0;
   if (i&1) nPos = 190-nPos;	// strzen
   if (i<6) {
    pScrollBar->SetScrollPos(nPos);
    SetDlgItemInt(IDC_SHOW_SLIDER0+i,nPos);
    CServo* pServo = CServo::GetServo(i+1);
    if (pServo) pServo->SetAngle((float)nPos);
    pServo->MoveRealServo();
    COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
   }
  }break;
 }
 CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CDlgStrgServoTester::OnTimer(UINT nIDEvent) {
 UpdateDlg();
 CDialog::OnTimer(nIDEvent);
}

void CDlgStrgServoTester::OnCancel() {
 TRACE("CDlgStrgServoTester::OnCancel()\n");
 m_bIsActive = false;
 DestroyWindow();
}

void CDlgStrgServoTester::OnBtnConnect() {
 if (gApp.m_SerialCom.IsConnected()) 
  gApp.m_SerialCom.ClosePort();
 else{
  gApp.m_SerialCom.ClosePort();
  gApp.m_SerialCom.OpenPort(CIniFile::m_pCIniFile->GetValueInt("COM","port"));
 }
 UpdateDlg();	
}

HBRUSH CDlgStrgServoTester::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	if(pWnd->GetDlgCtrlID() == IDC_CONNECTION_STATE2)
		if (gApp.m_SerialCom.IsConnected())
		{	pDC->SetTextColor( RGB(0,130,0) );
			//pDC->SetBkColor( RGB(0,255,0) ); 
		}
		else 
		{	pDC->SetTextColor( RGB(200,0,0) );
			//pDC->SetBkColor( RGB(255,0,0) ); 
		}
			
	return hbr;
}
