// DlgStrgSettings.cpp: Implementierungsdatei
// COM-Portauswahl, erweitert auf COM-Port-Nummern bis 32

#include "stdafx.h"
#include "hexmotion.h"
#include "DlgStrgSettings.h"
#include "Servo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgStrgSettings 


CDlgStrgSettings::CDlgStrgSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgStrgSettings::IDD, pParent)
{	m_bIsActive=false;
	m_strReceive="";
	//{{AFX_DATA_INIT(CDlgStrgSettings)
	m_nPortSelect = -1;
	m_bConnectOnStart = FALSE;
	m_strSend = _T("");
	m_strReceive = _T("");
	//}}AFX_DATA_INIT
}


void CDlgStrgSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgStrgSettings)
	DDX_Radio(pDX, IDC_PORT_SELECT, m_nPortSelect);
	DDX_Check(pDX, IDC_PORT_CONNECT_ON_START, m_bConnectOnStart);
	DDX_Text(pDX, IDC_EDIT_SEND, m_strSend);
	DDV_MaxChars(pDX, m_strSend, 20);
	DDX_Text(pDX, IDC_EDIT_RECEIVE, m_strReceive);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgStrgSettings, CDialog)
	ON_COMMAND_RANGE (IDC_PORT_SELECT, IDC_PORT_SELECT+3, OnPortSelect)

	//{{AFX_MSG_MAP(CDlgStrgSettings)
	ON_BN_CLICKED(IDC_BTN_DISCONNECT, OnBtnDisconnect)
	ON_BN_CLICKED(IDC_PORT_CONNECT_ON_START, OnPortConnectOnStart)
	ON_BN_CLICKED(IDC_BTN_SEND, OnBtnSend)
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	ON_EN_CHANGE(IDC_EDIT_SEND, OnChangeEditSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgStrgSettings 

BOOL CDlgStrgSettings::OnInitDialog() 
{	SetTimer(ID_UPDATETIMER_STRG_SETTINGS,500,NULL);	
	CDialog::OnInitDialog();
	UpdateDlg();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgStrgSettings::UpdateDlg() {	
 DWORD avail=gApp.m_SerialCom.GetAvailablePorts();
 int conn = gApp.m_SerialCom.GetConnectionPort();
 if (conn) avail|=1<<(conn-1);
 SetDlgItemText(IDC_CONNECTION_STATE,conn ? "verbunden mit "+gApp.m_SerialCom.GetName() : "nicht verbunden");
 int n=0;
 int port=1;
 for (; avail; avail>>=1, port++) {
  if (avail&1) {
   HWND w=::GetDlgItem(m_hWnd,IDC_PORT_SELECT+n);
   TCHAR s[8];
   _stprintf(s,_T("COM%u"),port);
   ::SetWindowText(w,s);
   ::EnableWindow(w,TRUE);
   if (conn==port) m_nPortSelect=n;
   n++;
   if (n>=4) break;
  }
 }
 for(;n<4;n++,port++) {
  HWND w=::GetDlgItem(m_hWnd,IDC_PORT_SELECT+n);
  TCHAR s[8];
  _stprintf(s,_T("COM%u"),port);
  ::SetWindowText(w,s);
  ::EnableWindow(w,FALSE);
 }

 GetDlgItem(IDC_BTN_DISCONNECT)->EnableWindow(conn);
 GetDlgItem(IDC_BTN_SEND)->EnableWindow(conn);
 GetDlgItem(IDC_EDIT_SEND)->EnableWindow(conn);
	
 m_bConnectOnStart=(CIniFile::m_pCIniFile->GetValueInt("COM","connect")>0);
	
 UpdateData(false);
}

void CDlgStrgSettings::OnPortSelect(UINT) { //changed by S.Wei 06.08.2007
 int sel=m_nPortSelect;		//m_nPortSelect {0..3} -1=no connection
 UpdateData(true);
 if (m_nPortSelect!=sel && m_nPortSelect>=0) {	// gendert
  gApp.m_SerialCom.ClosePort();
  TCHAR s[8];
  ::GetDlgItemText(m_hWnd,IDC_PORT_SELECT+m_nPortSelect,s,elemof(s));
  int port=StrToInt(s+3);
  if (gApp.m_SerialCom.OpenPort(port)) {
//		SetTimer(ID_RECEIVETIMER,500,NULL);
   CIniFile::m_pCIniFile->SetValue("COM","port",port);
  }else{
   OnBtnDisconnect();
  }
  UpdateDlg();
  CServo::MoveAllServos();
 }
}

void CDlgStrgSettings::OnBtnDisconnect() {
 gApp.m_SerialCom.ClosePort();
 KillTimer(ID_RECEIVETIMER);
 UpdateDlg();
}

void CDlgStrgSettings::OnPortConnectOnStart() {
 UpdateData(true);
 CIniFile::m_pCIniFile->SetValue("COM","connect",m_bConnectOnStart);
}

void CDlgStrgSettings::OnBtnSend() {
 char byte;
 UpdateData(true);
 if (m_strSend.GetLength()>0) for(int n=0;n<m_strSend.GetLength();n++){
  byte=m_strSend.GetAt(n);
  gApp.m_SerialCom.WriteByte(byte);
 }
}

void CDlgStrgSettings::OnTimer(UINT nIDEvent) 
{	unsigned char byte;
	int n=0;
	switch (nIDEvent)
	{	
	case ID_UPDATETIMER_STRG_SETTINGS:
		UpdateDlg();
		break;
	case ID_RECEIVETIMER:
		n=0;
		while (n<30)
		{ if(gApp.m_SerialCom.ReadByte(byte))
			{	//ACHTUNG VERWEILZEIT IN READBYTE() HNGT VON TIMEOUT-SETTINGS AB !!!
				TRACE("%c",byte);
				UpdateData(true);
				m_strReceive+=byte;
				if(m_strReceive.GetLength()>50)m_strReceive=m_strReceive.Right(49);
				UpdateData(false);
				n++;
			}
		  else n=100;

		}
		break;
	
	};
	CDialog::OnTimer(nIDEvent);
}

void CDlgStrgSettings::OnCancel()
{	bool DlgModal=false;	//Wurde der Dialog durch DoModal() erzeugt?
	TRACE("CDlgStrgSettings::OnCancel()\n");
	
	KillTimer(ID_UPDATETIMER_STRG_SETTINGS);
	m_bIsActive=false;
	
	if (DlgModal)		// Wenn Modal-Dialog erzeugt wurde ( DoModal() )
		EndDialog(0);	
	else				// Wenn Modeless-Dialog erzeugt wurde wurde ( Create(...)+ShowWindow(..) )
		DestroyWindow();

}

HBRUSH CDlgStrgSettings::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
// Derselbe Code war doch schon mal!
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	if(pWnd->GetDlgCtrlID() == IDC_CONNECTION_STATE)
		if (gApp.m_SerialCom.IsConnected())
		{	pDC->SetTextColor( RGB(0,130,0) );
			//pDC->SetBkColor( RGB(0,255,0) ); 
		}
		else 
		{	pDC->SetTextColor( RGB(200,0,0) );
			//pDC->SetBkColor( RGB(255,0,0) ); 
		}	
	return hbr;
}

void CDlgStrgSettings::OnOK()
{	//Ohne Inhalt da Return nicht als Abbruch fr Fenster benutzt wird.
	//Wenn OnOK() nicht berschrieben wird, dann wird dennoch die standart OnOK()-Version ausgefhrt.
	//OnCancel();
}

void CDlgStrgSettings::OnChangeEditSend() 
{
	UpdateData(true);
	// TODO: Fgen Sie hier Ihren Code fr die Benachrichtigungsbehandlungsroutine des Steuerelements hinzu

	
}
