// HexMotion.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//

#include "stdafx.h"
#include "HexMotion.h"
#include "MainFrm.h"

#include <gl\glu.h>   // Damit kann Glu32 genutzt werden.
#include <gl\gl.h>    // Damit kann OpenGL32 genutzt werden.
#include <gl\glaux.h> // Und das Gleiche nochmal fr Glaux  

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------ allgemeine Funktionen --------------------------------
float Round(float value,int nk) {
 float factor=1.0;
 for (;nk;nk--) (factor*=10.0);
 return floor(value*factor+0.5F)/factor;
}

void Round(float value[3], int nk, int len) {
 for (int i=0; i<len; i++) *value=Round(*value,nk), value++;
}

CString Convert(float number) {
 char buffer[50];
 _gcvt(number, 5, buffer);
 return (CString)buffer;
}

void TrimValue(float & value,float min,float max,bool bAbsolut)
{	//!bAsolut verschieben des Wertes in den Bereich
	//bAbsolut wenn Wert nicht im Bereich ist-> dann auf max/min setzen
	if (!bAbsolut)
	{	while (value>max) value-=(max-min);
		while (value<min) value+=(max-min);
	}else{
		if (value>max) value=max;
		if (value<min) value=min;
	}
}
void TrimValue(int & value,int min,int max,bool bAbsolut)
{	if (!bAbsolut)
	{	while (value>max) value-=(max-min);
		while (value<min) value+=(max-min);
	}else{
		if (value>max) value=max;
		if (value<min) value=min;
	}
}
void TrimValue(double & value,double min,double max,bool bAbsolut)
{	if (!bAbsolut)
	{	while (value>max) value-=(max-min);
		while (value<min) value+=(max-min);
	}else{
		if (value>max) value=max;
		if (value<min) value=min;
	}
}

// Quadrat berechnen
double sqr(double f) {
 return f*f;
}
float sqr(float f) {
 return f*f;
}

// Entfernung zweier Raumpunkte ermitteln (>=0)
float dist(const float p1[3], const float p2[3]) {
 return sqrt(sqr(p2[0]-p1[0])+sqr(p2[1]-p1[1])+sqr(p2[2]-p1[2]));
}

float GetVektorWinkel(const float MP[3], const float P1[3], const float P2[3])
{
	float winkel;
	float punktprodukt=   ((P1[0]-MP[0]) * (P2[0]-MP[0]) +
									(P1[1]-MP[1]) * (P2[1]-MP[1]) +
									(P1[2]-MP[2]) * (P2[2]-MP[2]));
	float V1Length= dist(P1,MP);
	float V2Length= dist(P2,MP);
	winkel = acos(punktprodukt/(V1Length*V2Length));
	return winkel;
}

double ABS(double wert)
{
	if (wert<0) return -wert;
	else return wert;
}

//following method added by S.Wei 21.12.2007, last change 12.02.2008
float EyeAngle(const float pointOfObject[3], const float pointOfView[3], float eyeoffset)
{
	float distance = (float)dist(pointOfObject,pointOfView);
	float erg = atan(eyeoffset/distance);//atan rechnet in Bogenma
	erg = erg/ 3.14159265358979323846f * 180;

	return erg; 
}



/////////////////////////////////////////////////////////////////////////////
// CHexMotionApp

BEGIN_MESSAGE_MAP(CHexMotionApp, CWinApp)
	//{{AFX_MSG_MAP(CHexMotionApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//CHexMotionApp *gpApp;

/////////////////////////////////////////////////////////////////////////////
// CHexMotionApp Konstruktion

CHexMotionApp::CHexMotionApp() {	
// gpApp = this;
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CHexMotionApp-Objekt

CHexMotionApp gApp;

/////////////////////////////////////////////////////////////////////////////
// CHexMotionApp Initialisierung

BOOL CHexMotionApp::InitInstance()
{	
	m_IniFile.SetPath("HexMotion.ini");
	m_IniFile.ReadFile();

	
	AfxEnableControlContainer();

	// Standardinitialisierung
	// Wenn Sie diese Funktionen nicht nutzen und die Gre Ihrer fertigen 
	//  ausfhrbaren Datei reduzieren wollen, sollten Sie die nachfolgenden
	//  spezifischen Initialisierungsroutinen, die Sie nicht bentigen, entfernen.

#ifdef _AFXDLL
	//Enable3dControls();	//is not longer needed		// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	// Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif

	// Dieser Code erstellt ein neues Rahmenfensterobjekt und setzt dies
	// dann als das Hauptfensterobjekt der Anwendung, um das Hauptfenster zu erstellen.
	CMainFrame* pFrame = new CMainFrame();
	//Fenster als Hauptfenster deklarieren 
	//IP_SET("m_pMainWnd",pFrame); - > verlagert in CMainFrame
	
	// Rahmen mit Ressourcen erstellen und laden

	pFrame->LoadFrame(IDR_MAINFRAME,WS_OVERLAPPEDWINDOW|FWS_ADDTOTITLE);
	pFrame->SetIcon(LoadIcon(IDR_MAINFRAME),TRUE);
		

	// Das einzige Fenster ist initialisiert und kann jetzt angezeigt und aktualisiert werden.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();
	
	//ggf. 3D-Modus einschalten
	if(CIniFile::m_pCIniFile->GetValueInt("3D", "init"))
	{
		pFrame->fullscreenData.get3D = true;
		pFrame->switch3DMode();
	}

	//ggf. COM-Port verbinden
	int port=CIniFile::m_pCIniFile->GetValueInt("COM","port");
	if (CIniFile::m_pCIniFile->GetValueInt("COM","connect")>0) 
	{
		m_SerialCom.OpenPort(port);
		//SetTimer(ID_UPDATETIMER_UART,100,NULL);
	};

	return TRUE;
}

//methodes, added by S.Wei, 07.12.2007, last change 10.12.2007
//
//Die Methoden speichern Zeiger auf Objekte ab.
//Objekte knnen Nummerierung oder Namen erhalten
//
BOOL CHexMotionApp::_Vorauswertung(CString &name, int &n)
{//-- Vorauswertung --
	if(name == "m_pCMainFrame")
	{
		name = "m_pMainWnd"; //das Objekt von CMainFrame ist das Hauptfenster //ggf. spter abndern
		return TRUE;
	}
	return FALSE;
}


int CHexMotionApp::setInstancePointer(CString art, void * ptr, int n /*= 0*/, CString name /* = ""*/)
{
	_Vorauswertung(name, n);
	//Zeigerrckgabe
	if(art == "m_pMainWnd")
	{
		m_pMainWnd = (CWnd *) ptr;
		return 0;
	}
	if(art == "m_pWnd")
	{
		NamedpWnd newnpWnd;
		newnpWnd.name = name;
		newnpWnd.ptr = (CWnd *) ptr;
		
		POSITION pos = m_pWnd.GetHeadPosition();
		if(n == 0)
		{//am Ende anfgen
			newnpWnd.number = getInstancePointerCount(art, name) + 1; 
			m_pWnd.AddTail(newnpWnd);
			return newnpWnd.number;
		}
		else
		{
			if(name == "")
			{//n-tes Element ersetzen
				newnpWnd.number = m_pWnd.GetCount() + 1; 
				int m = n;
				while(m > 1)
				{
					m_pWnd.GetNext(pos);
					m--;
				}
				m_pWnd.SetAt(pos, newnpWnd);
				return newnpWnd.number;
			}
			else
			{//benanntes Element mit Nummer n anfgen
				deleteInstancePointer(art, n, name);
				newnpWnd.number = n;
				m_pWnd.AddTail(newnpWnd);
				return newnpWnd.number;
			}
		}
	}
	return -1;
}

void * CHexMotionApp::getInstancePointer(CString art, int n /*= 0*/, CString name /* = ""*/)
{
	_Vorauswertung(art, n);
	//Zeigerrckgabe
	if(art == "m_pMainWnd")
	{
		return m_pMainWnd;
	}
	if(art == "m_pWnd")
	{
		if(name == "")
		{//namendlich ungenannt
			if((m_pWnd.GetCount() != 0) | (m_pWnd.GetCount() < n))
			{//nicht vorhandenes Element angefordert
				return NULL;
			}
			else
			{//Element vorhanden
				if(n == 0)
				{//letztes Element angefordert
					return ((NamedpWnd) m_pWnd.GetTail()).ptr;
				}
				else
				{//n-tes Element angefordert
					POSITION pos = m_pWnd.GetHeadPosition();
					int m = n;
					while(m > 1)
					{
						m_pWnd.GetNext(pos);
						m--;
					}
					return ((NamedpWnd)m_pWnd.GetAt(pos)).ptr;
				}
			}
		}
		else
		{//namendlich genannt
			POSITION pos = m_pWnd.GetHeadPosition();
			BOOL b = FALSE;
			for(int m = 1; m <= m_pWnd.GetCount(); m++)
			{
				if(	(((NamedpWnd) m_pWnd.GetAt(pos)).name == name) 
					& (	(((NamedpWnd) m_pWnd.GetAt(pos)).number == n) | (n == 0) ))//entweder die Nummer stimmt berein, oder das erste Element ist gefordert (n == 0)
				{//Genanntes gefunden
					b = TRUE;
					break;
				}
				m_pWnd.GetNext(pos);
			}
			if(b)
			{//Genanntes zurckgeben
				return ((NamedpWnd) m_pWnd.GetAt(pos)).ptr;
			}
			else
			{
				return NULL;
			}
		}
	}
	return NULL;
}

int CHexMotionApp::getInstancePointerCount(CString art, CString name /* = ""*/)
{
	if(art == "m_pWnd")
	{
		if(name == "")
		{
			return m_pWnd.GetCount();
		}
		else
		{
			POSITION pos = m_pWnd.GetHeadPosition();
			int n = 0;
			for(int m = 1; m <= m_pWnd.GetCount(); m++)
			{
				NamedpWnd newnpWnd = m_pWnd.GetNext(pos);
				if(newnpWnd.name == name)
				{
					if( n < newnpWnd.number)
					{
						n = newnpWnd.number;
					}
				}
			}
			return n;
		}
	}//end "m_pWnd"
	return 0;
}

BOOL CHexMotionApp::deleteInstancePointer(CString art, int n, CString name /* = "" */)
{
	if(art == "m_pWnd")
	{
		POSITION pos = m_pWnd.GetHeadPosition();
		if(name == "")
		{
			if(m_pWnd.GetCount() >= n)
			{
				for(int m = 1; m < n; m++)
				{
					m_pWnd.GetNext(pos);
				}
				m_pWnd.RemoveAt(pos);
				return TRUE;
			}
		} 
		else
		{
			BOOL b = FALSE;
			for(int m = 1; m <= m_pWnd.GetCount(); m++)
			{
				if(	(((NamedpWnd) m_pWnd.GetAt(pos)).name == name) & (((NamedpWnd) m_pWnd.GetAt(pos)).number == n))
				{//Genanntes gefunden
					b = TRUE;
					break;
				}
				m_pWnd.GetNext(pos);
			}
			if(b)
			{
				m_pWnd.RemoveAt(pos);
				return TRUE;
			}
		}
	}
	return FALSE;
}




// ------------------------- About-Dialog ------------------------------
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogdaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_strEdit1;
	//}}AFX_DATA

	// berladungen fr virtuelle Funktionen, die vom Anwendungs-Assistenten erzeugt wurden
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strEdit1 = _T("Dieses Programm wurde im Rahmen einer Studienarbeit an der TU Chemnitz entwickelt. Es ermglicht die Kopplung von virtuellem Modell und realer Maschine am Beispiel einer Parallelkinematik. Eine Anpassung an genderte Geometrie sowie an andere Kinematikkonzepte ist mglich.\r\n\r\nDer Quelltext ist zum Kotzen! (heha, 02/09, leicht berarbeitet)");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strEdit1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Anwendungsbefehl zum Ausfhren des Dialogfelds
void CHexMotionApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CHexMotionApp-Nachrichtenbehandlungsroutinen
