#pragma once

//////////////////////////////////////////////////////////////////////
// IniFile.h: interface for the CIniFile class.				//
// Written by:	Adam Clauss		pandcc3@comwerx.net		//
// Rewritten by Matthias Weber	wmat@mbv.tu-chemnitz.de  02/2003	//
// WAS IST DENN DAS FR EIN MLL!! heha
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// IniFile.h: CIniFile-Klasse						//
//																	//
// Bedienungsanleitung:		erstellt von Weber Matthias 03/2003	//
//																	//
// ----------------------------------------------------------------	//
// INI-Struktur:	[keyname]					//
//			valuename=value	;comment			//
//			valuename=value	;comment			//
//																	//
//			[keyname]					//
//			valuename=value	;comment			//
//																	//
// Es werden 2 Listen angelegt						//
//	1x Namen der Keys (keynames)= names	( array of CString	)		//
//	1x Inhalt der Keys			= keys	( array of struct	)		//
//																	//
// ----------------------------------------------------------------	//
// Erstellung:														//
//																	//
//	Klasse.SetPath("datei.ini");
//	Klasse.Reset();		// Neuerstellen	der Daten
//	Klasse.SetValue("KEY_A","Wert1",50,true);
//	Klasse.SetValue("KEY_A","Wert2","hallo",true);
//	Klasse.SetValue("KEY_A","Wert3",100.4,true);
//	Klasse.SetValueComment("KEY_A","Wert2","Kommentar");
//	Klasse.SetValue("KEY_B","Wert1",50,true);
//	Klasse.SetValue("KEY_B","Wert2","hallo",true);
//	Klasse.SetValue("KEY_B","Wert3",100.4,true);
//	Klasse.SetValueComment("KEY_A","Wert2","Kommentar");
//	Klasse.SetValue("KEY_C","Wert1",50,true);
//	Klasse.SetValue("KEY_C","Wert2","hallo",true);
//	Klasse.SetValue("KEY_C","Wert3",100.4,true);
//	Klasse.SetValueComment("KEY_A","Wert2","Kommentar");
//	//bis jetzt wurde noch nix gespeichert
//	//man kann aber dennoch schon auf die Zellen zugreifen
//																	//
//	Klasse.WriteFile();			// Erstellung der Datei
//																	//
// ----------------------------------------------------------------	//
// Resultat: "datei.ini"
//
// [KEY_A]
// Wert1=50			;Kommentar zum Wert
// Wert2=hallo
// Wert3=100.4
//
// [KEY_B]
// Wert1=50			;Kommentar zum Wert
// Wert2=hallo
// Wert3=100.4
//
// [KEY_C]
// Wert1=50			;Kommentar zum Wert
// Wert2=hallo
// Wert3=100.4
//
// ----------------------------------------------------------------	//
// Lesen															//
//																	//
//		Klasse.SetPath("datei.ini");								//
//		Klasse.ReadFile();	//Prfen auf RckgabeCode==0			//
//							//nun kann auf Zellen zugegriffn werden	//
//																	//
// ----------------------------------------------------------------	//
// Zugriff															//
//		SetValue("KEY_A","Wert1",51);								// ndern der Zeile (Comment bleibt erhalten)
//		SetValue("KEY_A","Wert4",100);								// hinzufgen der Zeile (ohne Comment)
//		int ix;														//
//		ix=GetValueInt("KEY_A","Wert4");							// liefert wert4 aus [KEY_A] als Integer
//		double dx;													//
//		dx=GetValueDouble("KEY_A","Wert3");							// liefert wert3 aus [KEY_A] als Double
//		CString sx;													//
//		sx=GetValue("KEY_A","Wert2");								// liefert wert2 aus [KEY_A] als CString
//		SetValueComment("KEY_A","Wert4","Komentar");				// fgt zu wert4 aus [KEY_A] einen Kommentar
//		sx=GetValueComment("KEY_A","Wert4");						// liefert den Kommentar zu wert4 aus [KEY_A]
//		SetValueComment("KEY_A","Wert1","");						// lscht den Kommentar zu wert1 aus [KEY_A]
//																	//
//////////////////////////////////////////////////////////////////////

#include <afxtempl.h>								//ntig fr dynamische Arrays (Klasse CArray)
//following code changed 06.08.2007 by S.Wei
//org: #include <iostream.h>
//-------------------------------------------------------//
//#warning <iostream.h> is not a standard c++ header
//#warning update this code to use <iostream>
#include <iostream>									//fr Dateiein-/ausgabe
using namespace std;
/*
using ::istream;
using std::ostream;
using std::cin;
using std::cout;
using std::cerr;
using std::clog;
using std::endl;
using std::ends;

using std::ios;
using std::flush;
*/
//--------------------------------------------------------//

class CIniFile  
{
private:

	CString path;									//Ort der IniDatei
	struct key
	{
		CArray<CString, CString> values;			//list of values in key
		CArray<CString, CString> names;				//corresponding list of value names
		CArray<CString, CString> comment;			//corresponding list of comments
	};
	CArray<key ,key> keys;							//list of keys in ini
	CArray<CString, CString> names;					//corresponding list of keynames

private:
	int		FindValue(int keynum,CString valuename) const;//returns index of specified value, in the specified key, or -1 if not found
	int		FindKey(CString keyname) const;				//returns index of specified key, or -1 if not found
	bool	getline(istream & is, CString & str) const;

public:	
	bool IsValue(CString strKeyName, CString strValueName) const;
	bool IsKey(CString strKeyName) const;

	static	CIniFile* m_pCIniFile;
	
	CIniFile();										//default constructor
	CIniFile(CString inipath);						//constructor, with filename
	virtual ~CIniFile();							//default destructor

	void	SetPath(CString newpath);				//sets path of ini file to read and write from
	CString	GetPath() const;
	bool	ReadFile();								//reads ini file specified using CIniFile::SetPath() 
													//returns true if successful, false otherwise
	void	WriteFile();							//writes data stored in class to ini file
	void	Reset();								//deletes all stored ini data

	int		GetNumKeys() const;							//returns number of keys currently in the ini
	int		GetNumValues(CString keyname) const;			//returns number of values stored for specified key

	CString GetValue		(CString keyname, CString valuename) const; //get [keyname] valuename = ____
	int		GetValueInt		(CString keyname, CString valuename) const; //get [keyname] valuename = ____ 
	float	GetValueDouble	(CString keyname, CString valuename) const; //get [keyname] valuename = ____
	void	GetValueTrFloat	(CString keyname, CString valuename,float V[3]) const;

	CString GetValueComment	(CString keyname, CString valuename) const; //get [keyname] valuename = value ;____
	
	bool	SetValue(CString key, CString valuename, CString value, bool create = 1);	//set [keyname] valuename =____
	bool	SetValue(CString key, CString valuename, int value, bool create = 1);		//set [keyname] valuename =____
	bool	SetValue(CString key, CString valuename, float value, bool create = 1);	//set [keyname] valuename =____
	bool	SetValue(CString key, CString valuename, const float V[3], bool create);

	bool	SetValueComment(CString keyname, CString valuename, CString Comment);//set [keyname] valuename = value ;____

	bool	DeleteValue(CString keyname, CString valuename);
	bool	DeleteKey(CString keyname);
};
