// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "Servo.h"
#include "Plattform.h"
#include "HexMotion.h"
#include "SerialCom.h"
#include "DlgStatus.h"
#include "MainFrm.h"
#include "Script.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//CMainFrame* CMainFrame::m_pCMainFrame;				//statischer pointer auf Instanz 

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	

	ON_COMMAND_RANGE			(ID_TOOL0, ID_TOOL4, OnToolBar)
	ON_UPDATE_COMMAND_UI_RANGE	(ID_TOOL0, ID_TOOL4, OnToolBarUpdate)
	
	ON_COMMAND_RANGE			(IDM_FIRST_ID,IDM_LAST_ID, OnMenu)
	ON_UPDATE_COMMAND_UI_RANGE	(IDM_FIRST_ID,IDM_LAST_ID, OnMenuUpdate)
	
	ON_COMMAND_RANGE			(ID_BTN_X_LEFT, ID_BTN_CENTER_ZERO, OnToolBar2)       //changed by S.Wei 16.08.2007
	ON_UPDATE_COMMAND_UI_RANGE	(ID_BTN_X_LEFT, ID_BTN_CENTER_ZERO, OnToolBar2Update) //changed by S.Wei 16.08.2007

	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_ACTIVATE()
	ON_WM_SETFOCUS()
	ON_WM_TIMER()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	//Fenster als Hauptfenster deklarieren 
	IP_SET("m_pMainWnd",this);
	//Fenster in der Liste aus Fensterzeigern aufnehmen, 0 = nchstgrere freie Nummer, unter dem Namen CMainFrame
	IP_SETNAMED("m_pMainWnd", this, 0, "CMainFrame");

	m_nBtnSelected = 0;
	fullscreenData.isFullScreen = false;
	fullscreenData.get3D = false;
	fullscreenData.is3D = false;

	//following lines added by S.Wei, 21.11.2007
	m_wndStatusBar	= new CStatusBar();
	m_wndToolBar	= new CToolBar();
	m_wndToolBar2	= new CToolBar();
}

CMainFrame::~CMainFrame()
{
	delete(m_wndStatusBar);
	delete(m_wndToolBar);
	delete(m_wndToolBar2);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
		
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	m_View1.Create(IDD_VIEW1, this);
	m_View2.Create(IDD_VIEW2, this);
	
	if (!m_wndToolBar->CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar->LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	if (!m_wndStatusBar->Create(this) ||
		!m_wndStatusBar->SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	if (!m_wndToolBar2->CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar2->LoadToolBar(IDR_PLATTFORM_TRANSLATION))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	// ZU ERLEDIGEN: Lschen Sie diese drei Zeilen, wenn Sie nicht wollen, dass die Symbolleiste
	//  andockbar ist.

	EnableDocking(CBRS_ALIGN_ANY);
	
	m_wndToolBar->EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(m_wndToolBar);
		
	m_wndToolBar2->EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(m_wndToolBar2);
//	::SetTimer(m_hWnd,ID_UPDATETIMER_UART,100, CMainFrame::Timer);
	return 0;
}

void CMainFrame::OnPaint()
{
	this->SendMessageToDescendants(WM_PAINT);
	CFrameWnd::OnPaint();
}
void CMainFrame::Timer(HWND hWnd, UINT nMsg, UINT_PTR nIDEvent, DWORD dwTime)
{
	OnTimer(nIDEvent);
}

void CMainFrame::OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized)
{
	m_wndView.OnActivate(nState, pWndOther, bMinimized);
	UpdateWindow();
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// Fokus an das Ansichtfenster weitergeben
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// Ansichtfenster erhlt ersten Eindruck vom Befehl
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// andernfalls die Standardbehandlung durchfhren
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnToolBar(UINT nCmdID)
{	//COpenGLScene* pScene =  COpenGLFunctions::m_pCOpenGLFunctions->m_Scene;
	//COpenGLFunctions* pOpenGL = COpenGLFunctions::m_pCOpenGLFunctions;
	CPlattform* pPlattform=NULL;
	CServo* pServo=NULL;
	COpenGLScene* scene = COpenGLFunctions::m_pCOpenGLFunctions->m_pScene;

	pPlattform=CPlattform::m_pCPlattform;
	int temp;
	switch (nCmdID)
	{
	case ID_TOOL0:
		//m_nPortSelect {0..3} -1=no connection
// Auch diesen Kode gibts schon mal woanders
		if (gApp.m_SerialCom.IsConnected())
			gApp.m_SerialCom.ClosePort();
		else
		{	gApp.m_SerialCom.ClosePort();
			gApp.m_SerialCom.OpenPort(CIniFile::m_pCIniFile->GetValueInt("COM","port"));
		}
		break;
	case ID_TOOL1:
		temp=scene->m_nMouseUsage;
		temp = (temp==MU_SCENE_TRANSLATE) ? MU_NO_USAGE : MU_SCENE_TRANSLATE;
		scene->m_nMouseUsage=temp;
		break;
	case ID_TOOL2:
		temp=scene->m_nMouseUsage;
		temp = (temp==MU_SCENE_TRANSLATE_INTO) ? MU_NO_USAGE : MU_SCENE_TRANSLATE_INTO;
		scene->m_nMouseUsage=temp;
		break;
	case ID_TOOL3:
		temp=scene->m_nMouseUsage;
		temp = (temp==MU_SCENE_ROTATE) ? MU_NO_USAGE : MU_SCENE_ROTATE;
		scene->m_nMouseUsage=temp;
		break;
	};
	COpenGLFunctions::m_pCOpenGLFunctions->DrawScene();
}

void CMainFrame::OnToolBarUpdate(CCmdUI *pCmdUI)
{
	switch (pCmdUI->m_nID)
	{
	case ID_TOOL0:	pCmdUI->SetCheck(gApp.m_SerialCom.IsConnected());										break;
	case ID_TOOL1:	pCmdUI->SetCheck(COpenGLFunctions::m_pCOpenGLFunctions->m_pScene->m_nMouseUsage==MU_SCENE_TRANSLATE);		break;
	case ID_TOOL2:	pCmdUI->SetCheck(COpenGLFunctions::m_pCOpenGLFunctions->m_pScene->m_nMouseUsage==MU_SCENE_TRANSLATE_INTO);break;
	case ID_TOOL3:	pCmdUI->SetCheck(COpenGLFunctions::m_pCOpenGLFunctions->m_pScene->m_nMouseUsage==MU_SCENE_ROTATE);		break;
	};
}

void CMainFrame::OnToolBar2(UINT nCmdID)
{//method modified by S.Wei, 03.01.2008	
	((CChildView *)IP_GETNAMED("m_pWnd", 0, "CChildView"))->OnActionCommand(nCmdID);
}

void CMainFrame::OnToolBar2Update(CCmdUI *pCmdUI)
{//method modified by S.Wei, 18.02.2008	
	pCmdUI->SetCheck(m_nBtnSelected==pCmdUI->m_nID);
}

void CMainFrame::OnMenu(UINT nCmdID)
{
	switch (nCmdID)
	{
	//following 3 case added by S.Wei 02.01.2008, last change 12.02.2008
	case ID_RECORDER_AUFNAHME:
		((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->OnActionCommand(nCmdID);
		break;
	case ID_RECORDER_WIEDERGABE:
		((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->OnActionCommand(nCmdID);
		break;
	case ID_RECORDER_STOP:
		((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->OnActionCommand(nCmdID);
		break;
	case ID_ANSICHT_VOLLBILD: //case added by S.Wei 24.10.2007
		FullScreen();
		break;
	case ID_ANSICHT_ZURUECKSETZEN: //case added by S.Wei, 02.01.2008
		((CChildView *) IP_GETNAMED("m_pWnd", 0, "CChildView"))->setScene(0,0,0,0,0,0);
		break;
	case ID_ANSICHT_3D: //case added by S.Wei, 17.02.2008
		dualView(true);
		break;
	case ID_STEUERUNG_JOYSTICK: //case added by S.Wei 11.09.2007
		if (!m_DlgConfigJoystick.m_bIsActive)
 			{	
				m_DlgConfigJoystick.Create(IDD_CONFIG_JOYSTICK, this);
 				m_DlgConfigJoystick.m_bIsActive=true;
 				m_DlgConfigJoystick.ShowWindow(SW_SHOW);
			} else
 			{
 				m_DlgConfigJoystick.m_bIsActive=false;
 				m_DlgConfigJoystick.DestroyWindow();
 			};
 		break;
	case ID_STEUERUNG_KEYBOARD: //case added by S.Wei 30.08.2007
 		if (!m_DlgConfigKeyboard.m_bIsActive)
 			{	
				m_DlgConfigKeyboard.Create(IDD_KONFIG_KEYBOARD, this);
 				m_DlgConfigKeyboard.m_bIsActive=true;
 				m_DlgConfigKeyboard.ShowWindow(SW_SHOW);
			} else
 			{
 				m_DlgConfigKeyboard.m_bIsActive=false;
 				m_DlgConfigKeyboard.DestroyWindow();
 			};
 		break;
	case ID_STEUERUNG_INFO3D: //case added by S.Wei 17.09.2007
		dlgInfo3DMaus.Create(IDD_DIALOG_INFO_3DMAUS, this);
		dlgInfo3DMaus.ShowWindow(SW_SHOW);
		break;
 	case IDM_STRG_SETTINGS:
 		if (!m_DlgStrgSettings.m_bIsActive)
 			{	m_DlgStrgSettings.Create(IDD_STRG_SETTINGS, this);
 				m_DlgStrgSettings.m_bIsActive=true;
 				m_DlgStrgSettings.ShowWindow(SW_SHOW);
			} else
 			{
 				m_DlgStrgSettings.m_bIsActive=false;
 				m_DlgStrgSettings.DestroyWindow();
 			};
 		break;
 	case IDM_STRG_SERVOTESTER:
 		if (!m_DlgStrgServoTester.m_bIsActive)
 			{	m_DlgStrgServoTester.Create(IDD_STRG_SERVOTESTER, this);
 				m_DlgStrgServoTester.m_bIsActive=true;
 				m_DlgStrgServoTester.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgStrgServoTester.m_bIsActive=false;
 				m_DlgStrgServoTester.DestroyWindow();
 			};
 		break;
	case IDM_SCENE_SETTINGS:
 		if (!m_DlgSceneSettings.m_bIsActive)
 			{	m_DlgSceneSettings.Create(IDD_SCENE_SETTINGS, this);
 				m_DlgSceneSettings.m_bIsActive=true;
 				m_DlgSceneSettings.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgSceneSettings.m_bIsActive=false;
 				m_DlgSceneSettings.DestroyWindow();
 			};
 		break;
	case IDM_SCENE_NAVIGATION:
 		if (!m_DlgSceneNavigation.m_bIsActive)
 			{	m_DlgSceneNavigation.Create(IDD_SCENE_NAVIGATION, this);
 				m_DlgSceneNavigation.m_bIsActive=true;
 				m_DlgSceneNavigation.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgSceneNavigation.m_bIsActive=false;
 				m_DlgSceneNavigation.DestroyWindow();
 			};
 		break;
	case IDM_LIGHT_SETTINGS:
 		if (!m_DlgLightSettings.m_bIsActive)
 			{	m_DlgLightSettings.Create(IDD_LIGHT_SETTINGS, this);
 				m_DlgLightSettings.m_bIsActive=true;
 				m_DlgLightSettings.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgLightSettings.m_bIsActive=false;
 				m_DlgLightSettings.DestroyWindow();
 			};
 		break;
	case IDM_OBJECT_SETTINGS:
 		if (!m_DlgObjectSettings.m_bIsActive)
 			{	m_DlgObjectSettings.Create(IDD_OBJECT_SETTINGS, this);
 				m_DlgObjectSettings.m_bIsActive=true;
 				m_DlgObjectSettings.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgObjectSettings.m_bIsActive=false;
 				m_DlgObjectSettings.DestroyWindow();
 			};
 		break;
	case IDM_SERVO_SETTINGS:
 		if (!m_DlgServoSettings.m_bIsActive)
 			{	m_DlgServoSettings.Create(IDD_SERVO_SETTINGS, this);
 				m_DlgServoSettings.m_bIsActive=true;
 				m_DlgServoSettings.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgServoSettings.m_bIsActive=false;
 				m_DlgServoSettings.DestroyWindow();
 			};
 		break;
	case IDM_PLATTFORM_SETTINGS:
 		if (!m_DlgPlattformSettings.m_bIsActive)
 			{	m_DlgPlattformSettings.Create(IDD_PLATTFORM_SETTINGS, this);
 				m_DlgPlattformSettings.m_bIsActive=true;
 				m_DlgPlattformSettings.ShowWindow(SW_SHOW);
 			} else
 			{
 				m_DlgPlattformSettings.m_bIsActive=false;
 				m_DlgPlattformSettings.DestroyWindow();
 			};
 		break;
	case IDM_VIEW_TOOLBAR2:
 		BOOL bVisible = ((m_wndToolBar2->GetStyle() & WS_VISIBLE) != 0);
		ShowControlBar(m_wndToolBar2, !bVisible, FALSE);
		RecalcLayout();
 		break;
 	};
 }

void CMainFrame::OnMenuUpdate(CCmdUI *pCmdUI)
{
	switch (pCmdUI->m_nID)
	{
		case IDM_STRG_SETTINGS:			pCmdUI->SetCheck(m_DlgStrgSettings.m_bIsActive);	break;
	 	case IDM_STRG_SERVOTESTER:		pCmdUI->SetCheck(m_DlgStrgServoTester.m_bIsActive);	break;
	 	case IDM_SCENE_SETTINGS:		pCmdUI->SetCheck(m_DlgSceneSettings.m_bIsActive);	break;
	 	case IDM_SCENE_NAVIGATION:		pCmdUI->SetCheck(m_DlgSceneNavigation.m_bIsActive);	break;
	 	case IDM_LIGHT_SETTINGS:		pCmdUI->SetCheck(m_DlgLightSettings.m_bIsActive);	break;
		case IDM_OBJECT_SETTINGS:		pCmdUI->SetCheck(m_DlgObjectSettings.m_bIsActive);	break;
		case IDM_SERVO_SETTINGS:		pCmdUI->SetCheck(m_DlgServoSettings.m_bIsActive);	break;
		case IDM_VIEW_TOOLBAR2:			pCmdUI->SetCheck((m_wndToolBar2->GetStyle() & WS_VISIBLE) != 0);	break;
		case ID_ANSICHT_VOLLBILD:		pCmdUI->SetCheck(fullscreenData.isFullScreen); break;//case added by S.Wei 24.10.2007
		
		case ID_RECORDER_AUFNAHME:		pCmdUI->Enable(CScript::m_pCScript == NULL); break;//case added by S.Wei, 02.01.2008
		case ID_RECORDER_WIEDERGABE:	pCmdUI->Enable(CScript::m_pCScript == NULL); break;//case added by S.Wei, 02.01.2008
		case ID_RECORDER_STOP:			pCmdUI->Enable(CScript::m_pCScript != NULL); break;//case added by S.Wei, 02.01.2008
	}
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{	
 static bool inside_command;
 static CString strCommand;
 switch (nIDEvent) {
  case ID_UPDATETIMER_UART: { //Beep(1000,100);
   if (gApp.m_SerialCom.IsConnected()) {			//existiert eine Verbindung?
    BYTE byte;
    while (gApp.m_SerialCom.ReadByte(byte)) {
     switch (byte) {
      case '(': {
       inside_command=true;
       strCommand="";
      }break;
      case ')': {
       inside_command=false;
       OnUartCommand(strCommand);
      }break;
      default: if (inside_command) strCommand+=byte;
     }
    }
   }
  }break;
 }
 UpdateWindow();
}

void CMainFrame::OnUartCommand(CString Command) {
 //method modified by S.Wei, 03.01.2008
// Ziemlich idiotisch!! Wre doch besser, SendInput() oder PostMessage() zu verwenden 
 UINT nCmdID;
 if (Command.GetLength()==3 && Command[0]=='K') {	// fr "Key"?
  if (Command[2]=='0') {				// fr "Low-Pegel"?
   nCmdID = Command[1]-'A'+ID_BTN_X_LEFT;	// 13 aufeinanderfolgende IDs, in der gleichen Reihenfolge wie in der Buttonleiste
  }else if (Command[2]=='1') {				// fr "High-Pegel"? (Loslassen)
   if ('A'<=Command[1] && Command[1]<='M') m_nBtnSelected=0;
  }
 }
	((CChildView *)IP_GETNAMED("m_pWnd", 0, "CChildView"))->OnActionCommand(nCmdID);
}

//following methode added by S.Wei 24.10.2007
void CMainFrame::FullScreen()
{
	FullScreen(!fullscreenData.isFullScreen);
}

//following methode added by S.Wei 10.10.2007, last change 29.11.2007
void CMainFrame::FullScreen(bool b)
{
	if(fullscreenData.is3D)
		return;	//wenn dass Programm im 3D-Modus ist, ist die Funktion deaktiviert

	//http://www.cpp-tutor.de/mfc/mfc/kap2/_intern/showwindow.htm
	if	(b == true)
	{
		if(fullscreenData.isFullScreen == false)
		{//eine Vernderung hat statt gefunden
			if(fullscreenData.visibleToolBar = m_wndToolBar->IsVisible())
			{
				SendMessage(0x111,0xe800,0x0);//Symbolleiste ausblenden
			}
			if(fullscreenData.visibleToolBar2 = m_wndToolBar2->IsVisible())
			{
				SendMessage(0x111,0x8089,0x0);//Bewegungsleiste ausblenden
			}
			if(fullscreenData.visibleStatusBar = m_wndStatusBar->IsVisible())
			{
				SendMessage(0x111,0xe801,0x0);//Statusleiste ausblenden
			}
			//Menu sichern
			fullscreenData.menu = ::GetMenu(m_hWnd);
			//Menu "ausblenden"
			::SetMenu(m_hWnd, NULL);

			//alte Ansicht speichern
			fullscreenData.oldWindowStyle = GetWindowLong(m_hWnd, GWL_STYLE);
			//Fenster maximieren
			ShowWindow(SW_MAXIMIZE);
			//Vollbild schalten
			SetWindowLong(m_hWnd, GWL_STYLE, WS_VISIBLE | WS_MAXIMIZE);
			
			fullscreenData.isFullScreen = true;
		}
	}
	else
	{
		if(fullscreenData.isFullScreen == true)
		{//eine Vernderung hat statt gefunden
			//alte nichtmaximierte Ansichtsgre sichern
			WINDOWPLACEMENT wpNew;
			GetWindowPlacement(&wpNew);
			
			//alte Ansicht wiederherstellen
			SetWindowLong(m_hWnd,GWL_STYLE, fullscreenData.oldWindowStyle ^ WS_MAXIMIZE);
			if(fullscreenData.oldWindowStyle & WS_MAXIMIZE)
			{//vor Vollbild maximiert
				ShowWindow(SW_MAXIMIZE);
				SetWindowPlacement(&wpNew); //alte nichtmaximierte Gre wiederherstellen
			}
			else
			{
				ShowWindow(SW_RESTORE);
			}
			
			//Menu wiederherstellen
			::SetMenu(m_hWnd, fullscreenData.menu);

			fullscreenData.isFullScreen = false;
			if(fullscreenData.visibleToolBar)
			{
				SendMessage(0x111,0xe800,0x0);//Symbolleiste einblenden
			}
			if(fullscreenData.visibleToolBar2)
			{
				SendMessage(0x111,0x8089,0x0);//Bewegungsleiste einblenden
			}
			if(fullscreenData.visibleStatusBar)
			{
				SendMessage(0x111,0xe801,0x0);//Statusleiste einblenden
			}
		}
	}
	UpdateWindow();
}

void CMainFrame::dualView(bool b)
{
	if(b != fullscreenData.is3D)
	{
		fullscreenData.get3D = b;
		switch3DMode();
	}
}

//method added by S.Wei 03.12.2007, last change 14.12.2007
void CMainFrame::switch3DMode()
{
	if(fullscreenData.get3D & !fullscreenData.is3D)
	{
		RECT rect1;
		RECT rect2;
		m_View1.ShowWindow(SW_NORMAL);
		m_View1.SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE);//Verschieben an den linken Bildschirmrand
		m_View1.ShowWindow(SW_MAXIMIZE);
		m_View1.GetWindowRect(&rect1);

		m_View2.ShowWindow(SW_NORMAL);
		m_View2.SetWindowPos(NULL, rect1.right, rect1.top, 0, 0, SWP_NOSIZE);//Verschieben ber den rechten Bildschirmrand hinaus
		m_View2.ShowWindow(SW_MAXIMIZE);
		m_View2.GetWindowRect(&rect2);

		if(rect1.right > rect2.left)
		{//Fenster berschneiden/berlagern sich (mgliche Ursache: kein 2.Anzeigegert angeschlossen)
			m_3DFehlermeldung.Create(IDD_FEHLERMELDUNG_3D, this);
			RECT rf3D;
			m_3DFehlermeldung.GetWindowRect(&rf3D);
			m_3DFehlermeldung.SetWindowPos(NULL, rect1.left + (rect1.right-rect1.left)/2 - (rf3D.right - rf3D.left)/2, rect1.top + (rect1.bottom-rect1.top)/2, 0, 0, SWP_NOSIZE);
 			m_3DFehlermeldung.ShowWindow(SW_SHOW);
			m_3DFehlermeldung.RedrawWindow();

			//Fehlerbehandlung: Beide Fenster werden nebeneinander auf der Primranzeige abgebildet
			m_View1.SetWindowPos(NULL, rect1.left, rect1.top, (rect1.right-rect1.left)/2, (rect1.bottom-rect1.top)/2, 0);
			m_View1.UpdateWindow();
		
			m_View2.SetWindowPos(NULL, rect1.left + (rect1.right-rect1.left)/2, rect1.top, (rect1.right-rect1.left)/2, (rect1.bottom-rect1.top)/2, 0);
			m_View2.UpdateWindow();
		}
		ShowWindow(SW_HIDE);
		fullscreenData.is3D = true;
	}
	else
	{
		m_View1.ShowWindow(SW_HIDE);
		m_View2.ShowWindow(SW_HIDE);
		m_3DFehlermeldung.DestroyWindow();
		ShowWindow(SW_SHOW);
		fullscreenData.is3D = false;
	}
}
