// OpenGLObject.cpp: Implementierung der Klasse COpenGLObject.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "gl\gl.h"			//OpenGL - Standartbefehle	z.B. glVertex3d(), ...
#include "gl\glu.h"			//OpenGL - Utilities		z.B. gluPerspective(), ...
//#include "gl\glaux.h"		//OpenGL - Hilfsbibliothek	z.B. auxSolidSphere(), ...
#include "OpenGLFunctions.h"
#include "OpenGLObject.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CList<COpenGLObject*,COpenGLObject*> COpenGLObject::m_pObjectList;
//COpenGLObject* COpenGLObject::GetObject(CString strName); //deaktiviert S.Wei 06.08.2007
//COpenGLObject* COpenGLObject::GetObject(int nObjectNr); //deaktiviert S.Wei 06.08.2007

COpenGLObject::COpenGLObject() {
 ZeroMemory(&m_fColor,sizeof(float)*(4+3+3+3+3));
	m_pObjectList.AddTail(this);
	m_nObjectNumber=m_pObjectList.GetCount();
	m_strStatus="passiv";
	char buffer[10];
	_itoa(m_nObjectNumber,buffer,10);
	m_strName="OpenGLObject";
	m_strName+=buffer;

	TRACE("COpenGLObject::COpenGLObject() (ObjectNr%d=\"%s\")\n",m_nObjectNumber,m_strName);

	SetShowGeometrie(true);
	SetShowOrigin(true);
}

COpenGLObject::COpenGLObject(CString strName,CString strStatus) {
 ZeroMemory(&m_fColor,sizeof(float)*(4+3+3+3+3));
	m_strStatus=strStatus;
	m_pObjectList.AddTail(this);
	m_nObjectNumber=m_pObjectList.GetCount();
	
	SetName(strName);
	
	TRACE("COpenGLObject::COpenGLObject() (ObjectNr%d=\"%s\")\n",m_nObjectNumber,m_strName);

	SetShowGeometrie(true);
	SetShowOrigin(true);
}

COpenGLObject::~COpenGLObject()
{	
	COpenGLObject* pObject;
	POSITION pos=COpenGLObject::m_pObjectList.GetHeadPosition();
	POSITION LastPos;
	CString temp;
	while (pos)
	{	LastPos=pos;
		pObject=COpenGLObject::m_pObjectList.GetNext(pos);
		if (pObject==this)
		{	if(glIsList(m_nListNumber))
			{	glDeleteLists(m_nListNumber,1);
				m_nListNumber=0;
			};
			COpenGLObject::m_pObjectList.RemoveAt(LastPos);
			TRACE("COpenGLObject::~COpenGLObject() (ObjectNr%d=\"%s\")\n",pObject->GetObjectNumber(),pObject->GetName());
		}
	};
}

void COpenGLObject::Draw()
{	bool smooth=(glIsEnabled(GL_POLYGON_SMOOTH)>0);
	glTranslatef(m_fPosition[0],m_fPosition[1],m_fPosition[2]);
	
	glRotatef(m_fOrientation[0],0.0,1.0,0.0);
	glRotatef(m_fOrientation[1],-1.0,0.0,0.0);
	glRotatef(m_fOrientation[2],0.0,0.0,1.0);

	if (m_bShowOrigin) DrawObjectDummy();
	
	glRotatef(m_fOrientationOffset[0],0.0,1.0,0.0);
	glRotatef(m_fOrientationOffset[1],-1.0,0.0,0.0);
	glRotatef(m_fOrientationOffset[2],0.0,0.0,1.0);

	glTranslatef(-m_fPositionOffset[0],-m_fPositionOffset[1],-m_fPositionOffset[2]);

	if (m_bShowGeometrie)
	{
		if ((m_fColor[3]>=1.0f)||(m_fColor[3]<0.0f))
		{
			glColor3f(m_fColor[0],m_fColor[1],m_fColor[2]);
			if (glIsList(m_nListNumber)) glCallList(m_nListNumber);
			else DrawObjectDummy();
		}
		else
		{	
			glDisable(GL_POLYGON_SMOOTH);
			glColor4d(m_fColor[0],m_fColor[1],m_fColor[2],m_fColor[3]);
			if (glIsList(m_nListNumber)) glCallList(m_nListNumber);
			else DrawObjectDummy();
			if (smooth) glEnable(GL_POLYGON_SMOOTH);
		}

	}
}
void COpenGLObject::DrawObjectDummy()
{	float breite=1;
	float schlitz=0.02F;
	float a=schlitz;
	float b=breite-schlitz;
	float c=breite;

	glPushMatrix();
		glDisable(GL_LIGHTING);
		glLineWidth(1.0);
		glColor3d(1.0,0.0,0.0);
		glBegin(GL_LINES);				//x-achse
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(c,0.0,0.0);
		glEnd();	
		glColor3d(0.0,1.0,0.0);
		glBegin(GL_LINES);				//y-achse
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(0.0,c,0.0);
		glEnd();	
		glColor3d(0.0,0.0,1.0);
		glBegin(GL_LINES);				//z-achse
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(0.0,0.0,c);
		glEnd();
		glPointSize(5.0);
		glColor3d(1.0,1.0,1.0);
		glBegin(GL_POINTS);				//origin
			glVertex3d(0.0,0.0,0.0);
		glEnd();
		
		if (COpenGLFunctions::m_pCOpenGLFunctions->m_pScene->m_bLight) 
			glEnable(GL_LIGHTING);				

		glPolygonMode(GL_FRONT,GL_FILL);
		glPolygonMode(GL_BACK,GL_LINE);
		glLineWidth(1.0);
		glColor3d(0.0,0.0,1.0);
		a/=2;
		b/=2;
		glBegin(GL_TRIANGLES);	//back
			glNormal3d(0.0,0.0,-1.0);
			glVertex3d(a,a,0.0);	glVertex3d(a,b,0.0);	glVertex3d(b,a,0.0);
			glNormal3d(0.0,0.0,1.0);
			glVertex3d(a,a,0.0);	glVertex3d(b,a,0.0);	glVertex3d(a,b,0.0);
		glEnd();
		glBegin(GL_TRIANGLES);	//left
			glNormal3d(-1.0,0.0,0.0);
			glVertex3d(0.0,a,a);	glVertex3d(0.0,a,b);	glVertex3d(0.0,b,a);
			glNormal3d(1.0,0.0,0.0);
			glVertex3d(0.0,a,a);	glVertex3d(0.0,b,a);	glVertex3d(0.0,a,b);
		glEnd();
		glBegin(GL_TRIANGLES);	//bottom
			glNormal3d(0.0,-1.0,0.0);
			glVertex3d(a,0.0,a);	glVertex3d(b,0.0,a);	glVertex3d(a,0.0,b);
			glNormal3d(0.0,1.0,0.0);
			glVertex3d(a,0.0,a);	glVertex3d(a,0.0,b);	glVertex3d(b,0.0,a);
		glEnd();	
	glPopMatrix();

}



CString	COpenGLObject::GetName()		{	return m_strName;			}
CString COpenGLObject::GetGeometrieFile(){	return m_strGeometrieFile;	}
CString COpenGLObject::GetStatus()		{	return m_strStatus;			}
int		COpenGLObject::GetObjectNumber(){	return m_nObjectNumber;		}
bool	COpenGLObject::GetShowGeometry(){	return m_bShowGeometrie;		}
bool	COpenGLObject::GetShowOrigin()	{	return m_bShowOrigin;		}


void	COpenGLObject::SetName(CString strName)	{	m_strName=strName;	}
void	COpenGLObject::SetShowGeometrie(bool doit){	m_bShowGeometrie=doit;}
void	COpenGLObject::SetShowOrigin(bool doit)	{	m_bShowOrigin=doit;	}


void COpenGLObject::SetGeometrie(CString strFileName)
{	bool ok=false;
	m_strGeometrieFile=strFileName;
	if (!glIsList(m_nListNumber)) m_nListNumber = glGenLists(1);
	glNewList(m_nListNumber, GL_COMPILE);
		glPushMatrix();	
			glPolygonMode(GL_FRONT,GL_FILL);
			glPolygonMode(GL_BACK,GL_FILL);
			ok=COpenGLFunctions::m_pCOpenGLFunctions->IncludeSTLGeometry(strFileName);
		glPopMatrix();
	glEndList();
	if ((glIsList(m_nListNumber))&&(!ok)){ glDeleteLists(m_nListNumber,1);m_nListNumber=0;};
}


COpenGLObject* COpenGLObject::GetObject(CString strName)
{
	COpenGLObject* pObject;
	POSITION pos=COpenGLObject::m_pObjectList.GetHeadPosition();
	CString temp;
	while (pos)
	{	pObject=COpenGLObject::m_pObjectList.GetNext(pos);
		if (pObject->GetName()==strName) return pObject;
	};
	return NULL;
}
COpenGLObject* COpenGLObject::GetObject(int nObjectNr)
{
	COpenGLObject* pObject;
	POSITION pos=COpenGLObject::m_pObjectList.GetHeadPosition();
	CString temp;
	while (pos)
	{	pObject=COpenGLObject::m_pObjectList.GetNext(pos);
		if (pObject->GetObjectNumber()==nObjectNr) return pObject;
	};
	return NULL;
}

void COpenGLObject::MoveToPosition()
{
//	glTranslatef(m_fPosition[0],m_fPosition[1],m_fPosition[2]);
	glTranslatef(	m_fPosition[0]-m_fPositionOffset[0],
					m_fPosition[1]-m_fPositionOffset[1],
					m_fPosition[2]-m_fPositionOffset[2]);
	glRotatef(m_fOrientation[0],0.0,1.0,0.0);
	glRotatef(m_fOrientation[1],1.0,0.0,0.0);
	glRotatef(m_fOrientation[2],0.0,0.0,1.0);
}


void COpenGLObject::GetColor(float x[4]) const{
 CopyMemory(x,m_fColor,sizeof(m_fColor));
}
void COpenGLObject::GetPosition(float x[3]) const{
 CopyMemory(x,m_fPosition,sizeof(m_fPosition));
}
void COpenGLObject::GetPositionOffset(float x[3]) const{
 CopyMemory(x,m_fPositionOffset,sizeof(m_fPositionOffset));
}
void COpenGLObject::GetOrientation(float x[3]) const{
 CopyMemory(x,m_fOrientation,sizeof(m_fOrientation));
}
void COpenGLObject::GetOrientationOffset(float x[3]) const{
 CopyMemory(x,m_fOrientationOffset,sizeof(m_fOrientationOffset));
}

void COpenGLObject::SetPosition(float x, float y, float z) {
 m_fPosition[0]=x;
 m_fPosition[1]=y;
 m_fPosition[2]=z;
}
void COpenGLObject::SetPositionOffset(float x, float y, float z) {
 m_fPositionOffset[0]=x;
 m_fPositionOffset[1]=y;
 m_fPositionOffset[2]=z;
}
void COpenGLObject::SetOrientation(float a, float b, float c) {
 m_fOrientation[0]=a;
 m_fOrientation[1]=b;
 m_fOrientation[2]=c;
}
void COpenGLObject::SetOrientationOffset(float a, float b, float c) {
 m_fOrientationOffset[0]=a;
 m_fOrientationOffset[1]=b;
 m_fOrientationOffset[2]=c;
}

void COpenGLObject::SetColor(float r, float g, float b,float alpha) {
 m_fColor[0]=r;
 m_fColor[1]=g;
 m_fColor[2]=b;
 m_fColor[3]=alpha;
}

void COpenGLObject::SetPosition(const float x[3]) {
 CopyMemory(m_fPosition,x,sizeof(m_fPosition));
}
void COpenGLObject::SetPositionOffset(const float x[3]) {
 CopyMemory(m_fPositionOffset,x,sizeof(m_fPositionOffset));
}
void COpenGLObject::SetOrientation(const float x[3]) {
 CopyMemory(m_fOrientation,x,sizeof(m_fOrientation));
}
void COpenGLObject::SetOrientationOffset(const float x[3]) {
 CopyMemory(m_fOrientationOffset,x,sizeof(m_fOrientationOffset));
}
void COpenGLObject::SetColor(const float x[4]) {
 CopyMemory(m_fColor,x,sizeof(m_fColor));
}
