//X_3DMouse.h - Headerdatei fr X_3DMouse.cpp
/**	Diese Klasse C3DMouse liefert die bentigten Methoden, um bei installierter 3DxWare eine 3DMouse zu nutzen.
	Sie ist auf die Verwendung durch Hexapod/Hexmotion zugeschnitten worden.
	Ausgegliedert: S.Wei 20.11.2007

Zu beachten: Entsprechend der Implementierung greift die Klasse auf die Methode ActionFromInteractionDevice der Klasse CChildView zu.
*/
#pragma once
#include "Si/si.h"
#include "Si/siapp.h"
#include <wia.h>

#define x3DMouse_THRESHOLD				0

class C3DMouse {
//Konstruktoren/Destruktor
public:
 C3DMouse();
 virtual ~C3DMouse();

 static	C3DMouse* m_pC3DMouse;
 bool	is3DMouseOn;
 void	Terminate3DMouse();
 BOOL	PreTranslateMessage(MSG* pMsg);

private:
 SiHdl	hdl_3DMouse;		/* 3DxWare device handle */
 void	Init3DMouse();
 void	On3DMouse(SiSpwEvent event_3DMouse, SiGetEventData eventData_3DMouse);
};
